#include <DoQuBook/PluginLoader.hpp>
#include <DoQuBook/DoQuBookDeamon.hpp>
#include <DoQuBook/Repository.hpp>
#include <DoQuBook/ApplicationContext.hpp>


using namespace DoQuBook;

QString orgName ("labri");

/// Must be the name of the target in CMake
QString appName ("DoQuBookDeamon");


/*class DoQuBookDeamonApp : public QtService<QApplication>
{
public :
    DoQuBookDeamonApp(int argc, char **argv)
        : QtService<QApplication>(argc, argv, "DoQuBookDeamonApp")
        , deamon (*application(), orgName, appName)
    {
        setServiceDescription("Executes DoQuBookWeb Tasks");
        //setServiceFlags(QtServiceBase::NeedsStopOnShutdown);
    }

protected:

    void start() {
        qDebug() << "test";
        deamon.run();
    }
    void stop()
    {
        deamon.setStopped(true);
        qDebug() << "STOP";

        deamon.terminate();
        deamon.wait();
        qDebug() << "Ended";
    }
    void pause() {
        qDebug() << "Hello Pause";
        application()->quit();
    }
    void resume() {}
    void processCommand(int code) {}

    DoQuBookDeamon deamon;

};*/

#if defined(Q_OS_WIN)
#elif defined(Q_OS_MAC) || defined(Q_OS_LINUX)
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <fstream>
#endif
DoQuBookDeamon *deamon = NULL;


#if defined(Q_OS_WIN)
#elif defined(Q_OS_MAC) || defined(Q_OS_LINUX)
void doqubook_SIGS_handler(int s) {
    printf("DoQuBookDeamon_main.cpp : Caught signal %d\n",s);

    if(s == SIGKILL
            || s == SIGQUIT
            || s == SIGTERM
            || s == SIGINT
            || s == SIGHUP) {
	
        deamon->unregister();
        exit(0);
    }
}
#endif

int main(int argc, char **argv)
{
    //launchctl load /Users/zoolonly/Library/LaunchAgents/com.labri.DoQuBookDeamon.plist
    //launchctl start com.labri.DoQuBookDeamon
    //launchctl stop com.labri.DoQuBookDeamon
    QApplication app (argc, argv);
    deamon = new DoQuBookDeamon(app, orgName, appName);

    /// TODO : On WIndows we can rederect the close signal of QApplication
#if defined(Q_OS_WIN)
#elif defined(Q_OS_MAC) || defined(Q_OS_LINUX)
    struct sigaction sigIntHandler;

    sigIntHandler.sa_handler = doqubook_SIGS_handler;
    sigemptyset(&sigIntHandler.sa_mask);
    sigIntHandler.sa_flags = 0;

    sigaction(SIGINT, &sigIntHandler, NULL);
    sigaction(SIGTERM, &sigIntHandler, NULL);
#endif

    qDebug() << argv[1];
    if(QString(argv[1]) == "-i") {
        deamon->installAsDaemon();
        return 0;
    } if(QString(argv[1]) == "-r") {
        deamon->uninstallDaemon();
        return 0;
    } else
        return  deamon->exec();
}
