#ifndef JAVAINTERFACESERVICEBUILDER_HPP
#define JAVAINTERFACESERVICEBUILDER_HPP

#include <QFile>
#include "JavaClassBuilder.hpp"

class CRUDMethods
{
public:
    CRUDMethods (bool create, bool read, bool update, bool del);


    bool create();
    bool read();
    bool update();
    bool del();

private :
    bool _create;
    bool _read;
    bool _update;
    bool _del;
};

class Method {
public :
    Method (const QString &name);

    void addParam (const Field &f);

    QList<Field> getParams();

private :
    QString type;
    QString _name;
    QList<Field> _params;
};

class JavaInterfaceServiceBuilder
{
public:
    JavaInterfaceServiceBuilder();

    void toFile ();
    void setName (const QString &name);
    void setCrudMethods (const CRUDMethods  &crudmethods);
    void setEntity (const QString &name);

private :
    QString _name;
    CRUDMethods _crudmethods;
    QString _entityName;
};

#endif // JAVAINTERFACESERVICEBUILDER_HPP
