#ifndef MAINWINDOW_HPP
#define MAINWINDOW_HPP

#include <QMainWindow>
#include <QtGui>

#include <DoQuBook/PluginLoader.hpp>
#include "PluginRunner.hpp"

class MainWindow : public QMainWindow
{
    Q_OBJECT
public:
    explicit MainWindow(QWidget *parent = 0);

    
signals:
    void pluginSelected(std::tr1::shared_ptr<DoQuBook::AlgorithmOnTask> plugin);
    
public slots:
    void setPluginLoader(DoQuBook::PluginLoader *loader);
    void pluginNameSelected (const QString &s);
    void setPluginRunner(PluginRunner *runner);

    void run();

    void openImages();

private :
    QWidget *_images;
    QWidget *_main;
    QVBoxLayout *_mainVBoxLayout;
    QLabel  *_leftLabel;
    QLabel  *_rightLabel;
    QLabel *_score;
    QGridLayout *_layout;
    QScrollArea *_scrollArea;
    QComboBox *box;
    DoQuBook::PluginLoader *_loader;
    PluginRunner *_runner;

    QStringList _fileNames;

};

#endif // MAINWINDOW_HPP
