#ifndef PLUGINPARAMETERCONFIGURATOR_HPP
#define PLUGINPARAMETERCONFIGURATOR_HPP

#include <QtGui>
#include <DoQuBook/PluginLoader.hpp>


class ImageParameterWidget : public QWidget {
    Q_OBJECT
public :
    explicit ImageParameterWidget (QWidget *parent = 0);

public slots :
    void browse();
    QImage selectedImage();

private :
    QPushButton _browse;
    QLineEdit _path;
    QHBoxLayout _layout;
    QString _realPath;
};

class PluginParameterConfigurator : public QDialog
{
    Q_OBJECT
public:
    explicit PluginParameterConfigurator(QWidget *parent = 0);
    
signals:
    void pluginConfigured(std::tr1::shared_ptr<DoQuBook::AlgorithmOnTask> plugin, const QVariantMap &params);
    
public slots:
    void pluginSelected(std::tr1::shared_ptr<DoQuBook::AlgorithmOnTask> plugin);
    void configured ();

private :
    QVBoxLayout *_layout;
    QPushButton *_okButton;
    QWidget *_paramsWidget;
    QVBoxLayout *_paramsLayout;
    QLabel *title;
    QMap<QWidget*, QString> paramsName;
    std::tr1::shared_ptr<DoQuBook::AlgorithmOnTask> _plugin;
    
};

#endif // PLUGINPARAMETERCONFIGURATOR_HPP
