#include <DoQuBook/PluginLoader.hpp>
#include <DoQuBook/Book.hpp>
#include <DoQuBook/DoQuBookApp.hpp>
#include <DoQuBook/RectoVersoRegistration.hpp>
#include <QPainter>
#include <DoQuBook/AttachmentServices.hpp>
#include <DoQuBook/Repository.hpp>
#include <DoQuBook/ApplicationContext.hpp>
#include <DoQuBook/Binarizer.hpp>
#include <DoQuBook/ImageFilter.hpp>
#include <DoQuBook/Measurer.hpp>
#include <DoQuBook/OCR.hpp>
#include <DoQuBook/StringComparator.hpp>
#include <DoQuBook/ImageComparator.hpp>

#include "MainWindow.hpp"
#include "PluginParameterConfigurator.hpp"
#include "PluginRunner.hpp"

using namespace DoQuBook;

QString orgName ("labri");

/// Must be the name of the target in CMake
QString appName ("PluginExperiments");



void updatePage(PageServicePtr pageService, PagePtr page) {
    pageService->update(page);
}

class BleedThroughAnalysis : public DoQuBook::DoQuBookApp
{
public :
    static const int HEIGHT = 600;
    static const int WIDTH = 800;
    static const int NB_IMAGE = 3;

    BleedThroughAnalysis (QApplication &app)
        : DoQuBook::DoQuBookApp(app, orgName, appName)
        , _loader (NULL)
    {


    }

protected :


    virtual void runApp(QMap<QString, QString> )
    {
			        _loader = DoQuBook::PluginLoader::instance();
			        _loader->loadPlugins();


			//        QImage img0 ("/Users/zoolonly/Pictures/DocSynthetiques/doc1.doc/image_0_.png");
			//        QImage img1 ("/Users/zoolonly/Pictures/DocSynthetiques/doc1.doc/image_1_.png");
			//        QList<QImage> imgs;
			//        imgs << img0 << img1;

			//        _window.setInputImages(imgs);
			        _window.setPluginRunner(&runner);

			//        connect(&_window, SIGNAL(pluginSelected(QSharedPointer<DoQuBook::AlgorithmOnTask>)),
			//                &_pluginConfigurator, SLOT(pluginSelected(QSharedPointer<DoQuBook::AlgorithmOnTask>)));
			        _window.setPluginLoader(_loader);

			        _window.show();

    }



    void showImages(const QImage &truth, const QImage &bin) {

//        QLabel *l = new QLabel;
//        l->setPixmap (QPixmap::fromImage(truth.scaled(800,800,Qt::KeepAspectRatio)));
//        QLabel *r = new QLabel;
//        r->setPixmap (QPixmap::fromImage(bin.scaled(800,800,Qt::KeepAspectRatio)));

//        _layout->addWidget(l);
//        _layout->addWidget(r);

    }

private :
    RepositoryPtr _repo;
    PluginLoader *_loader;

    MainWindow _window;
    PluginRunner runner;

};

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);

    BleedThroughAnalysis test (app);

    return test.exec();
}
