#ifndef PLUGIN_HPP
#define PLUGIN_HPP

#include <DoQuBook/SimpleMarshallable.hpp>

class Plugin;
typedef QSharedPointer<Plugin> PluginPtr;

class Plugin : public SimpleMarshallable
{
    Q_OBJECT

  public:
    MARSHALLABLE_CREATE_FONCTIONS (Plugin)
    explicit Plugin(QObject *parent = 0);

    QString getId() const;

    QString getOrganizationName() const;

    QString getDescription() const;

    QString getAlgorithmName() const;

    QString getVersion() const;

    QString getCategory() const;

    QString getVersionControlUrl() const;

  public slots:
    void setId(QString arg);

    void setOrganizationName(QString arg);

    void setDescription(QString arg);

    void setAlgorithmName(QString arg);

    void setVersion(QString arg);

    void setCategory(QString arg);

    void setVersionControlUrl(QString arg);

  protected :
    Q_PROPERTY (QString id READ getId WRITE setId)
    Q_PROPERTY (QString organizationName READ getOrganizationName WRITE setOrganizationName)
    Q_PROPERTY (QString description READ getDescription WRITE setDescription)
    Q_PROPERTY (QString algorithmName READ getAlgorithmName WRITE setAlgorithmName)
    Q_PROPERTY (QString version READ getVersion WRITE setVersion)
    Q_PROPERTY (QString category READ getCategory WRITE setCategory)
    Q_PROPERTY (QString versionControlUrl READ getVersionControlUrl WRITE setVersionControlUrl)

  private :
    QString m_id;

    QString m_organizationName;

    QString m_description;

    QString m_algorithmName;

    QString m_version;

    QString m_category;

    QString m_versionControlUrl;

};

#endif // PLUGIN_HPP
