#ifndef DBWEBDAEMONSERVICE_HPP
#define DBWEBDAEMONSERVICE_HPP


#include <DoQuBook/DoQuBook_global.hpp>
#include <DoQuBook/DaemonService.hpp>
#include <DoQuBook/RESTObjectManager.hpp>
#include <DoQuBook/Intlist.hpp>
#include <DBWebIterator.hpp>

namespace  DoQuBook
{

    class TaskRestIterator;
    typedef QSharedPointer<TaskRestIterator> TaskRestIteratorPtr;


    class DoQuBookSHARED_EXPORT TaskRestIterator : public SimpleMarshallable, public Iterator<TaskPtr>
    {
            Q_OBJECT
        public :
            Q_PROPERTY (QList<TaskPtr> elements READ getElements WRITE setElements)
            Q_PROPERTY (QUrl nextUrl READ getNextUrl WRITE setNextUrl)

            REST_ITERATOR (Task)
    };

    class DBWebDaemonService ;
    typedef QSharedPointer<DBWebDaemonService> DBWebDaemonServicePtr;

    class DoQuBookSHARED_EXPORT DBWebDaemonService : public DaemonService
    {
        public:
            DBWebDaemonService (const QString & serverAdress);
            virtual ~DBWebDaemonService();

            virtual Daemon downloadToken();
            virtual void registerExecutor (ExecutorPtr & exec, const Daemon & d);
            virtual bool unRegister (const Daemon & d);
            virtual bool isRegisteredExecutor (ExecutorPtr exec, const Daemon & d);
            virtual meta_iterator<TaskPtr>::IteratorPtr  getNewTasks (const Daemon & d);

        private :
            MarshallableFormaterPtr m_marshaller;
            QString m_serverUrl;
            QString m_rest_service_url;
            QString m_downloadTokenUrl;

            RESTObjectManager<Executor> m_executorManager;
            RESTObjectManager<TaskRestIterator> m_taskIdsManager;

    };

}

#endif // DBWEBDAEMONSERVICE_HPP
