#ifndef DBWEBFEATURESERVICE_HPP
#define DBWEBFEATURESERVICE_HPP
#include <DoQuBook/DoQuBook_global.hpp>

#include <DoQuBook/FeaturesService.hpp>
#include <DoQuBook/RESTObjectManager.hpp>

#include <DBWebIterator.hpp>

namespace DoQuBook
{

    class DBWebFeatureService ;
    typedef QSharedPointer<DBWebFeatureService> DBWebFeatureServicePtr;

    class GlobalNamedFeatureRestIterator;
    typedef QSharedPointer<GlobalNamedFeatureRestIterator> GlobalNamedFeatureRestIteratorPtr;


    class DoQuBookSHARED_EXPORT GlobalNamedFeatureRestIterator : public SimpleMarshallable, public Iterator<GlobalNamedFeaturePtr>
    {
            Q_OBJECT
        public :
            Q_PROPERTY (QList<GlobalNamedFeaturePtr> elements READ getElements WRITE setElements)
            Q_PROPERTY (QUrl nextUrl READ getNextUrl WRITE setNextUrl)

            REST_ITERATOR (GlobalNamedFeature)
    };

    class DBWebFeatureService : public FeatureService
    {

        public:
            DBWebFeatureService (const QString & serverAdress);
            virtual GlobalNamedFeaturePtr addGlobalNamedFeatureToPage (PagePtr page, QString featureName, double featureValue) ;
            virtual meta_iterator<GlobalNamedFeaturePtr>::IteratorPtr getGlobalNamedFeaturesOfPage (PagePtr page);

        private :
            MarshallableFormaterPtr m_marshaller;
            QString m_restServiceURL;
            RESTObjectManager<GlobalNamedFeature> m_globalNamedFeatureManager;
            RESTObjectManager<GlobalNamedFeatureRestIterator> m_getAllManager;
    };

}

#endif // DBWEBFEATURESERVICE_HPP
