#ifndef DBWEBITERATOR_HPP
#define DBWEBITERATOR_HPP

#include <QUrl>
#include <DoQuBook/MarshallableFormater.hpp>
#include <MarshallableFormaterFactory.hpp>
#include <DoQuBook/Iterator.hpp>

#define REST_ITERATOR(T) \
\
    MARSHALLABLE_CREATE_FONCTIONS (T ## RestIterator) \
    MARSHALLABLE_MLIST (QList, T, elements) \
    MARSHALLABLE_ACTIV_1LIST (elements, m_elements) \
\
    virtual QString entityName() {return "restiterator";} \
 \
    T ## RestIterator () \
        : currentIndex (-1) \
    {} \
\
    bool hasNext() { \
        if(!m_marshaller) \
            m_marshaller = DoQuBook::DBWebRepo::MarshallableFormaterFactory::instance()->create(); \
        if(currentIndex+1 < m_elements.size()) { \
            return true; \
        } else { \
            if(m_nextUrl.toString() != "") { \
                RESTObjectManager<T ## RestIterator> itManager (WebClient::JSON, m_marshaller); \
                itManager.addRessourcePath(WebClient::GET, m_nextUrl.toString()); \
\
                QMap<QString, QString> params; \
                T ## RestIteratorPtr list = itManager.get(params); \
                configure(list.data());\
                currentIndex = -1; \
                m_elements = list->getElements(); \
                m_nextUrl = list->getNextUrl(); \
                return currentIndex+1 < m_elements.size(); \
            } else { \
                return false; \
            } \
        } \
    } \
\
    T ## Ptr next() { \
        currentIndex++; \
        T ## Ptr tmpElem = m_elements.at(currentIndex); \
        preNext(tmpElem); \
        return tmpElem; \
    } \
\
    QList<T ## Ptr> getElements() const \
    { \
        return m_elements; \
    } \
\
    QUrl getNextUrl() const \
    { \
        return m_nextUrl; \
    } \
\
public slots: \
    void setElements(QList<T ## Ptr> arg) \
    { \
        m_elements = arg; \
    } \
\
    void setNextUrl(QUrl arg) \
    { \
        m_nextUrl = arg; \
    } \
\
private : \
    int currentIndex; \
\
    QList<T ## Ptr> m_elements; \
\
    QUrl m_nextUrl; \
\
    MarshallableFormaterPtr m_marshaller; \



#endif // DBWEBITERATOR_HPP
