#ifndef DBWEBPAGECOLLECTIONSERVICE_HPP
#define DBWEBPAGECOLLECTIONSERVICE_HPP

#include <QObject>

#include <DoQuBook/Page.hpp>
#include <DoQuBook/RESTObjectManager.hpp>
#include <DoQuBook/Intlist.hpp>
#include <DoQuBook/StringList.hpp>

#include <DoQuBook/PageCollectionService.hpp>

#include <DBWebPageService.hpp>

namespace DoQuBook {
  namespace DBWebRepo {
    class DBWebPageCollectionService : public QObject, public DoQuBook::PageCollectionService
    {
        Q_OBJECT
      public:
        DBWebPageCollectionService (const QString & serverAdress);

        virtual void addPage (const QString & collectionName, DoQuBook::PagePtr & page);
        virtual QList<int> getPagesIds (const QString & collectionName);
        virtual QList<QString> getAll ();

        virtual meta_iterator<DoQuBook::PagePtr>::IteratorPtr getPages (const QString & collectionName);

      private :
        MarshallableFormaterPtr m_marshaller;
        QString m_serverAdress;
        DoQuBook::RESTObjectManager<DoQuBook::Page> m_collectionPageManager;
        DoQuBook::RESTObjectManager<DoQuBook::PageRestIterator> m_pageListManager;
        DoQuBook::RESTObjectManager<DoQuBook::Intlist> m_pageIdsManager;
        DoQuBook::RESTObjectManager<DoQuBook::StringList> m_idsManager;
        DoQuBook::PageService * m_pageService;
    };
  }
}

#endif // DBWEBPAGECOLLECTIONSERVICE_HPP
