#include "DBWebPageEvent.hpp"


#include <DBWebImageService.hpp>

#include <MarshallableFormaterFactory.hpp>
using namespace DoQuBook;
using namespace DoQuBook::DBWebRepo;

DBWebPageEvent::DBWebPageEvent (const QString &serveradress, const QString subscriptionUrl, QObject *parent)
: PageEvent(parent)
, _serveradress (serveradress)
, _eventHandler (subscriptionUrl, MarshallableFormaterFactory::instance()->create())
{
    _eventHandler.addObserver (this);
    _eventHandler.listen();
}

void DBWebPageEvent::postUnMarshall(const DoQuBook::PagePtr &object)
{
    object->installImageService (new DBWebImageService (_serveradress) );
}

void DBWebPageEvent::addFunctor(Functor<Page> *f)
{
    _eventHandler.addObserver(f);
}
