#ifndef DBWEBPAGEEVENT_HPP
#define DBWEBPAGEEVENT_HPP

#include <DoQuBook/Future.hpp>
#include <DoQuBook/Page.hpp>
#include <DoQuBook/PageEvent.hpp>

namespace DoQuBook {
  namespace DBWebRepo {
    /**
 * @brief The DBWebPageEvent class provides a PageEvent using a HttpEventHandler.
 */
    class DBWebPageEvent : public PageEvent {

      public :
        DBWebPageEvent (const QString &serveradress, const QString subscriptionUrl, QObject *parent = NULL);
        virtual void postUnMarshall(const DoQuBook::PagePtr &object);

        void addFunctor(Functor<Page> *f);

      private :
        QString _serveradress;
        HttpEventHandler<Page> _eventHandler;
    };
  }
}

#endif // DBWEBPAGEEVENT_HPP
