#ifndef DBWEBPERFORMANCEMETRICSERVICE_HPP
#define DBWEBPERFORMANCEMETRICSERVICE_HPP

#include <DoQuBook/PerformanceMetricService.hpp>
#include <DoQuBook/Intlist.hpp>

#include <DBWebCRUDService.hpp>
#include <DBWebPageService.hpp>

namespace DoQuBook
{


    class DBWebPerformanceMetricService ;
    typedef QSharedPointer<DBWebPerformanceMetricService> DBWebPerformanceMetricServicePtr;


    class DBWebPerformanceMetricService : public PerformanceMetricService , public DBWebCRUDService<PerformanceMetric, int>
    {
        public:
            DBWebPerformanceMetricService (const QString & serverAdress);
            virtual ~DBWebPerformanceMetricService();

            virtual void addToPage (QSharedPointer<PerformanceMetric> &obj, PagePtr page) ;
            virtual meta_iterator<PagePtr>::IteratorPtr getPagesByMetricName (const QString & metricName);

            virtual PerformanceMetricPtr getByPageMetricNameAndAlgorithmName (PagePtr page, QString metricName, QString algorithmName);

            /// \todo refactor
            virtual QString convert (const int & id) {
                return QString::number (id);
            }
        private :
            RESTObjectManager<PageRestIterator> m_pagesByMetricNameManager;
            RESTObjectManager<PerformanceMetric> m_getByPageAndNames;
    };

}

#endif // DBWEBPERFORMANCEMETRICSERVICE_HPP
