#include "DBWebPredictionModelResultService.hpp"


using namespace DoQuBook;

DBWebPredictionModelResultService::DBWebPredictionModelResultService (const QString & serverAdress)
    : resourceBaseURl (serverAdress + "/DoQuBookWeb/rest/predictionmodelresult")
{
}

DBWebPredictionModelResultService::~DBWebPredictionModelResultService()
{
}

void DBWebPredictionModelResultService::create (QString name, QString description)
{
    WebClient c;
    c.setContentType (WebClient::JSON);
    QString templateUri = resourceBaseURl + "/create/(name)/(description)";
    templateUri.replace ("(name)", name);
    templateUri.replace ("(description)", description);
    QUrl url (templateUri);
    c.sendSynchronous (url, WebClient::GET, "");
}

void DBWebPredictionModelResultService::addPredictionModelMetric (QString modelName, QString metricName, double value)
{
    WebClient c;
    c.setContentType (WebClient::JSON);
    QString templateUri = resourceBaseURl + "/addTo/(name)/metric/(mname)/(mvalue)";
    templateUri.replace ("(name)", modelName);
    templateUri.replace ("(mname)", metricName);
    templateUri.replace ("(mvalue)", QString::number (value) );
    QUrl url (templateUri);

    c.sendSynchronous (url, WebClient::GET, "");
}

void DBWebPredictionModelResultService::addPagePredictionError (QString modelName, int pageId, double value)
{

    WebClient c;
    c.setContentType (WebClient::JSON);
    QString templateUri = resourceBaseURl + "/addTo/(name)/pagepredictionerror/(pageId)/(value)";
    templateUri.replace ("(name)", modelName);
    templateUri.replace ("(pageId)", QString::number (pageId) );
    templateUri.replace ("(value)", QString::number (value) );
    QUrl url (templateUri);

    c.sendSynchronous (url, WebClient::GET, "");
}
