#include "DBWebTaskImageService.hpp"

using namespace DoQuBook;

DBWebTaskImageService::DBWebTaskImageService (const QString & serverAdress)
    : m_serverAdress (serverAdress)
    , m_imageManager (RESTImageManager::PNG)
{
    m_restServicesUrl = "DoQuBookWeb/rest/imagetask";

    QString getImageUrl (m_serverAdress + "/" + m_restServicesUrl + "/(task_id)/(uuid)");
    m_imageManager.addRessourcePath (WebClient::GET, getImageUrl);

    QString postImageUrl (m_serverAdress + "/" + m_restServicesUrl + "/(task_id)");
    m_imageManager.addRessourcePath (WebClient::POST, postImageUrl);

}

QImage DBWebTaskImageService::get (TaskPtr task, QString uuid)
{
    QMap<QString, QString> params;
    params["task_id"] = QString::number (task->getId() );
    params["uuid"] = uuid;

    return m_imageManager.get (params);
}

QUrl DBWebTaskImageService::add (const QImage & image, TaskPtr task)
{
    QMap<QString, QString> params;
    params["task_id"] = QString::number (task->getId() );

    QByteArray array = m_imageManager.post (image, "original.png", params);
    QString u (array);

    return QUrl (u);
}
