#ifndef DOQUBOOKWEBREPOSITORY_HPP
#define DOQUBOOKWEBREPOSITORY_HPP

#include <DoQuBook/DoQuBook_global.hpp>
#include <DoQuBook/Repository.hpp>
#include <QSharedPointer>
#include <PluginConfig.hpp>

namespace DoQuBook
{
  class DoQuBookSHARED_EXPORT DoQuBookWebRepository : public Repository
  {

      Q_OBJECT
      DQB_PLUGIN(DoQuBook::Repository, Repository_iid)
      public:
        DoQuBookWebRepository();


      virtual RepositoryPtr clone();


      virtual PageServicePtr getPageService();
      virtual BookServicePtr getBookService();
      virtual ImageServicePtr getImamgeService();
      virtual PageCollectionServicePtr getPageCollectionService();
      virtual TaskServicePtr getTaskService();
      virtual TaskImageServicePtr getTaskImageService();
      virtual TempImageServicePtr getTempImageService();
      virtual ExecutorServicePtr getExecutorService();
      virtual DaemonServicePtr getDaemonService();
      virtual GroundTruthServicePtr getGroundTruthService();
      virtual PerformanceMetricServicePtr getPerformanceMetricService();
      virtual FeatureServicePtr getFeatureService();
      virtual PredictionModelResultServicePtr getPredictionModelResultService();

      virtual QList<RemotePluginFactory * > getRemotePluginFactories();

      virtual void setParam (QVariant v);

      virtual QVariant getParam();

      virtual RepositoryParamWidgetType widgetType() ;

      void setCredentials (const QString login, const QString & password);

      virtual void merge (MarshallablePtr /*other*/) {}

      // From Pluginbase but really not needed !!!!!
      virtual QString pluginType ()  {return "Repository";}
      virtual QString returnType() {return "Void";}

    protected :
      QString m_login;
      QString m_password;
      QString m_serverURl;
  };

}
#endif // DOQUBOOKWEBREPOSITORY_HPP
