#ifndef TESTANNOTATIONSERVICE_HPP
#define TESTANNOTATIONSERVICE_HPP

class TestAnnotationService : public QObject {

    Q_OBJECT

  public :
    TestAnnotationService()
      : service (new DBWebAnnotationService ("http://localhost:8080"))
    {

    }
    ~TestAnnotationService() {}

  public :
    void qDebugAnnotation(const AnnotationPtr &ann);
    void cleanUpAllAddedAnnotationOfPage(const PagePtr &page);

  private slots :

    void testSimpleAddToPage();

    void testAttributes();
    void testAddGetDelAnnotationLocal();
    void testSupportedTypesOfValue ();
    void testGetAllNames();
    void testGetPagesByAnnotationName();
    void testGetAnnotationByPageAndByName();

    /**
      * Called before each test function is executed.
      */
    void init();

    /**
      * Called after every test function.
      */
    void cleanup();
  private :
    AnnotationServicePtr service;

};


#endif // TESTANNOTATIONSERVICE_HPP
