#include "TestDoQuBookWebRepositoryPlugin.hpp"

#include <DoQuBook/PluginLoader.hpp>
#include <DoQuBook/ApplicationContext.hpp>
#include <DoQuBook/Repository.hpp>



using namespace DoQuBook;

TestDoQuBookWebRepositoryPlugin::TestDoQuBookWebRepositoryPlugin()
{
}

void TestDoQuBookWebRepositoryPlugin::testPluginLoading()
{
  ApplicationContext::instance()->deactivateInternetPlugins();

  PluginLoader *loader = PluginLoader::instance();
  loader->setPluginDirPath("./plugins/");

  try {
    RepositoryPtr repo = loader->getPlugin<Repository>("DBWebRepository");
    QVERIFY(repo->getName() == "");
    PageServicePtr pageService = repo->getPageService();
    PagePtr defaultEptyRepoPage = pageService->get(1);
    QVERIFY(defaultEptyRepoPage.isNull());

    RepositoryPtr digidoc = ApplicationContext::instance()->getRepository("digidoc");

    QVERIFY(digidoc->getName() == "digidoc");
    PageServicePtr digidocPageService = digidoc->getPageService();
    PagePtr digidocPage = digidocPageService->get(1);
    QVERIFY(!digidocPage.isNull());

    RepositoryPtr gallifrey = ApplicationContext::instance()->getRepository("Gallifrey");
    QVERIFY(gallifrey->getName() == "Gallifrey");

    QVERIFY(true);
  } catch(MessageException e) {
    qDebug() << e.message();
    QVERIFY(false);
  }
}

/*void TestDoQuBookWebRepositoryPlugin::tempSave()
{
  QVariantList repos;

  QVariantMap repoConf;
  QVariantMap repo;

  repo["plugin"] = "labri.DBWebRepository.0.0.1";
  repo["name"] = "Gallifrey";
  repoConf["url"] = "http://sd-22392.dedibox.fr:8080";
  repo["conf"] = repoConf;


  QVariantMap repoConf2;
  QVariantMap repo2;

  repo2["plugin"] = "labri.DBWebRepository.0.0.1";
  repo2["name"] = "digidoc";
  repoConf2["url"] = "http://digidoc-repo.labri.fr";
  repo2["conf"] = repoConf2;

  repos << repo << repo2;


  QJson::Serializer serializer;
  serializer.setIndentMode(QJson::IndentFull);
  QByteArray array = serializer.serialize (repos);

  QFile file(repo["name"].toString()+".json");
  file.open(QIODevice::WriteOnly);
  file.write(array);
  file.close();
}*/

void TestDoQuBookWebRepositoryPlugin::init()
{

}

void TestDoQuBookWebRepositoryPlugin::cleanup()
{

}

QTEST_MAIN(TestDoQuBookWebRepositoryPlugin)
