#include "DoQuBookOpenCVConverter.hpp"
#include <QDebug>
#include <DoQuBook/ApplicationContext.hpp>
#include <QDir>

using namespace DoQuBook;

DoQuBookOpenCVConverter::DoQuBookOpenCVConverter()
{
}
DoQuBookOpenCVConverter::~DoQuBookOpenCVConverter()
{}

cv::Mat DoQuBook::DoQuBookOpenCVConverter::getCvMat (const QImage & image)
{
    QImage qimage = image.convertToFormat (QImage::Format_ARGB32);

    cv::Mat mat = cv::Mat (qimage.height(), qimage.width(), CV_8UC4, (uchar *) qimage.bits(), qimage.bytesPerLine() );
    cv::Mat mat2 = cv::Mat (mat.rows, mat.cols, CV_8UC3 );
    int from_to[] = { 0, 0,  1, 1,  2, 2 };
    cv::mixChannels ( &mat, 1, &mat2, 1, from_to, 3 );

    return mat2;

    /*QString tempRepoPath = ApplicationContext::instance()->getTempRepoPath();
    QDir tempRepoDir (tempRepoPath);
    tempRepoDir.mkdir("conversions");
    QString imagePath = tempRepoDir.absolutePath()+"/conversions/tmpConvertImage.png";
    qDebug() << "Saving to image path " << imagePath;
    image.save(imagePath);

    cv::Mat mat = cv::imread(imagePath.toStdString());
    tempRepoDir.rmdir("conversions");
    return mat;*/
}

QImage DoQuBook::DoQuBookOpenCVConverter::getQImage (const cv::Mat & image)
{

    cv::Mat toBeConverted (image.rows, image.cols, cv::DataType<cv::Vec3b>::type);
    cv::Mat rgb;

    /* if(image.type() == cv::DataType<float>::type) {
         cv::Mat final (image.rows, image.cols, cv::DataType<cv::Vec3b>::type);
         for(int x = 0 ; x < image.rows; x++){
             for(int y = 0 ; y < image.cols; y++){
                 float g = image.at<float> (x, y);
                 final.at<cv::Vec3b>(x,y) [0] = (int) g;
                 final.at<cv::Vec3b>(x,y) [1] = (int) g;
                 final.at<cv::Vec3b>(x,y) [2] = (int) g;
             }
         }
         toBeConverted = final.clone();
     }*/

    if (image.channels() == 1) {
        cv::cvtColor (image, rgb, CV_GRAY2RGB);
    }
    else {
        rgb = image;
    }


    if (rgb.type() == cv::DataType<float>::type) {

        int nl = toBeConverted.rows; // number of lines
        int nc = toBeConverted.cols ; // number of columns

        // is it a continous image?
        if (rgb.isContinuous() )  {
            nc = nc * nl;
            nl = 1; // it is now a 1D array
        }

        for (int j = 0; j < nl; j++) {
            // pointer to first column of line j
            float * data = rgb.ptr<float> (j);
            uchar * outData = toBeConverted.ptr<uchar> (j);
            for (int i = 0; i < nc; i++) {
                /// 3 channels
                *outData++ = *data++;
                *outData++ = *data++;
                *outData++ = *data++;
            }
        }
    }
    else {
        toBeConverted = image;
    }

    QImage qImage (
        rgb.data,
        rgb.size().width,
        rgb.size().height,
        rgb.step,
        QImage::Format_RGB888
    );


    return qImage.rgbSwapped();
}




/*
QImage Camera::cvMatToQImage(const cv::Mat&amp; image) const
{
    QImage qImage(
        image.data,
        image.size().width,
        image.size().height,
        image.step,
        QImage::Format_RGB888
    );

    return qImage.rgbSwapped();
}


Mat qimage2mat(const QImage& qimage) {
    cv::Mat mat = cv::Mat(qimage.height(), qimage.width(), CV_8UC4, (uchar*)qimage.bits(), qimage.bytesPerLine());
    cv::Mat mat2 = cv::Mat(mat.rows, mat.cols, CV_8UC3 );
    int from_to[] = { 0,0,  1,1,  2,2 };
    cv::mixChannels( &mat, 1, &mat2, 1, from_to, 3 );
    return mat2;
};

QImage mat2qimage(const Mat& mat) {
    Mat rgb;
    cvtColor(mat, rgb, CV_BGR2RGB);
    return QImage((const unsigned char*)(rgb.data), rgb.cols, rgb.rows, QImage::Format_RGB888);
};



00124 QImage GLWidget::mat2qimage(const cv::Mat& mat)
00125 {
00126         cv::Mat rgb;
00127         cv::cvtColor(mat, rgb, CV_BGR2RGB);
00128
00129         return QImage((const unsigned char*)(rgb.data), rgb.cols, rgb.rows, QImage::Format_RGB888);
00130 }


00113 cv::Mat GLWidget::qimage2mat(const QImage& qimage)
00114 {
00115         cv::Mat mat = cv::Mat(qimage.height(), qimage.width(), CV_8UC4, (uchar*)qimage.bits(), qimage.bytesPerLine());
00116         cv::Mat mat2 = cv::Mat(mat.rows, mat.cols, CV_8UC3 );
00117         int from_to[] = { 0,0,  1,1,  2,2 };
00118         cv::mixChannels( &mat, 1, &mat2, 1, from_to, 3 );
00119
00120         return mat2;
00121 }
00122
  */

/*cv::Mat DoQuBook::Page::getCvMat()
{
    QString path = qApp->applicationDirPath();
    //QString path = "/Users/zoolonly";
    QImage qimage = getImage();
    qimage.save(path+"/tmp.png");
    if(!qimage.save(path+"/tmp.jpg")) {
        qCritical() << "!! could not save data to"+path+"/tmp.jpg";
        qCritical() << "=== This may be caused by the folowing reasons : ";
        qCritical() << "=== 1 - (Mac os x) the bundle is not well created and qt plugins are not installed";
        qCritical() << "=== 2 - QImage must be used after the initialization of a QApplication (to load qt plugins)";
        qCritical() << "=== 3 - You do not have the right to write / read in the temporary folder";
    }

    std::string s = QString(path+"/tmp.png").toStdString();
    cv::Mat mat = cv::imread(s);
    if(mat.rows == 0 && mat.cols == 0) {
        qWarning() << "!! OpenCV could not read the image";
        qWarning() << "=== This may be due to the folowing reasons :";
        qWarning() << "===  1 - the file "+path+"/tmp.jpg is not on disk" ;
        qWarning() << "===  2 - Qt Plugins (imageformats) are not loaded" ;
        qWarning() << "===  3 - An error on OpenCV fixup_bundle on Mac OS X" ;

    }
    return mat;

    //        QImage qimage = getImage();
    //        cv::Mat mat = cv::Mat(10, 10, CV_8UC3, cv::Scalar(0, 0 ,0));
    ////        const uchar* blaat = (const uchar*)qimage.bits();
    //        //mat.data = (uchar*)blaat;
    //        mat.data = (uchar*)qimage.bits();
    //        return mat ;

     QImage qimg = getImage();
        IplImage *imgHeader = cvCreateImageHeader( cvSize(qimg.width(), qimg.height()), IPL_DEPTH_8U, 4);
        imgHeader->imageData = (char*) qimg.bits();

        uchar* newdata = (uchar*) malloc(sizeof(uchar) * qimg.byteCount());
        memcpy(newdata, qimg.bits(), qimg.byteCount());
        imgHeader->imageData = (char*) newdata;

        qDebug() << "here";
        return cv::Mat(imgHeader);


            image = image.convertToFormat(QImage::Format_RGB32);
        cv::Mat mat = cv::Mat(image.height(), image.width(), CV_8UC4, (uchar*)image.bits(), image.bytesPerLine());
        cv::Mat mat2 = cv::Mat(mat.rows, mat.cols, CV_8UC3 );
        int from_to[] = { 0,0,  1,1,  2,2 };
        cv::mixChannels( &mat, 1, &mat2, 1, from_to, 3 );
        return mat2;
}*/
