
#ifndef QJSONMarshallableFormater_HPP
#define QJSONMarshallableFormater_HPP

#include <DoQuBook/DoQuBook_global.hpp>
#include <PluginConfig.hpp>
#include <DoQuBook/MarshallableFormater.hpp>
#include <QSharedPointer>

class QJSONMarshallableFormater : public MarshallableFormater
{
    Q_OBJECT
    DQB_PLUGIN(MarshallableFormater, MarshallableFormater_iid)

    virtual QString pluginType () {return "MarshallableFormater";}
    virtual QString returnType() {return "Void";}

    void addIgnoredProp (const QString & prop);

    virtual bool accept(const QString &/*contentType*/);
    virtual QString contentType();

    virtual void unMarshall (const QByteArray & file, QSharedPointer<Marshallable> dest);
    virtual void marshall (QSharedPointer<Marshallable> m, QString * dest);

  protected :
    QStringList ignoredProps;
};

#endif
