#ifndef CRUDSERVICE_HPP
#define CRUDSERVICE_HPP


#include <DoQuBook/DoQuBook_global.hpp>
#include <QSharedPointer>

namespace DoQuBook
{

    template <class Resource, class IdType>
    class DoQuBookSHARED_EXPORT CRUDService
    {
        public :
            virtual ~CRUDService() {}
            virtual QSharedPointer<Resource> get (const IdType & id) = 0;
            virtual void add (QSharedPointer<Resource>  &obj) = 0;
            virtual void update (QSharedPointer<Resource>  &obj) = 0;
            virtual bool del (const QSharedPointer<Resource> &obj) = 0;
            virtual bool del (const IdType & id) = 0;
    };

}

#endif // CRUDSERVICE_HPP
