#ifndef DBWEBMEASURERREMOTEPROXY_HPP
#define DBWEBMEASURERREMOTEPROXY_HPP

#include <DoQuBook/Measurer.hpp>
#include <DoQuBook/Repository.hpp>
#include <DoQuBook/RemotePluginFactory.hpp>

class DBWebMeasurerRemoteProxy : public Measurer
{
        Q_OBJECT
    public:

        class MeasurerRemotePluginFactory : public DoQuBook::RemotePluginFactory
        {
            public :
                MeasurerRemotePluginFactory() {}

                virtual bool accepts (DoQuBook::RepositoryPtr repo, DoQuBook::ExecutorPtr exec)  {
                    m_repo = repo;
                    m_exec = exec;
                    return  exec->getPluginType() == "Measurer";
                }

                virtual QObject * build();
                virtual void unLoad();
                virtual RemotePluginFactory * clone();
        };

        DBWebMeasurerRemoteProxy (DoQuBook::RepositoryPtr repo,
                                  DoQuBook::ExecutorPtr executor);


        virtual QString organisationName () ;
        virtual QString description () ;
        virtual QString algorithmName ();
        virtual QString version();
        virtual QString pluginType () ;


        virtual QMap<QString, double> measure (QList<QImage> &images, const QVariantMap & params = QVariantMap() );

    private :
        void convert (const QList<QImage> &images, QList<QVariant> &variants);

        void convert (const QVariant & variant, QMap<QString, double> &measures);

        DoQuBook::RepositoryPtr _repo;
        DoQuBook::ExecutorPtr _executor;
};

#endif // DBWEBMEASURERREMOTEPROXY_HPP
