#include "DBWebTempImageService.hpp"

using namespace DoQuBook;

DBWebTempImageService::DBWebTempImageService (const QString & serverAdress)
    : m_serverAdress (serverAdress)
    , m_imageManager (RESTImageManager::PNG)
{
    m_restServicesUrl = "DoQuBookWeb/rest/imagetemp";

    QString getImageUrl (m_serverAdress + "/" + m_restServicesUrl + "/(id)");
    m_imageManager.addRessourcePath (WebClient::GET, getImageUrl);

    QString postImageUrl (m_serverAdress + "/" + m_restServicesUrl);
    m_imageManager.addRessourcePath (WebClient::POST, postImageUrl);

}

QUrl DBWebTempImageService::add (QImage image)
{
    QMap<QString, QString> params;
    QByteArray array = m_imageManager.post (image, "original.png", params);
    QString u (array);
    return QUrl (u);
}

QImage DBWebTempImageService::get (QUrl url)
{
    QMap<QString, QString> params;

    RESTImageManager imageManager (RESTImageManager::PNG);
    imageManager.addRessourcePath (WebClient::GET, url.toString() );

    return imageManager.get (params);
}
