#ifndef DAEMONSERVICE_H
#define DAEMONSERVICE_H

#include <QSharedPointer>
#include <DoQuBook/Executor.hpp>
#include <DoQuBook/Task.hpp>
#include <DoQuBook/Iterator.hpp>

namespace DoQuBook
{

    class DaemonService;
    typedef QSharedPointer<DaemonService> DaemonServicePtr;

    typedef QString Daemon;

    class DaemonService
    {
        public:
            DaemonService() {}
            virtual ~DaemonService() {}

            virtual Daemon downloadToken() = 0;
            virtual void registerExecutor (ExecutorPtr & exec, const Daemon & d) = 0;
            virtual bool unRegister (const Daemon & d) = 0;
            virtual bool isRegisteredExecutor (ExecutorPtr exec, const Daemon & d) = 0;
            virtual meta_iterator<TaskPtr>::IteratorPtr  getNewTasks (const Daemon & d) = 0;

    };

}

#endif // DAEMONSERVICE_H
