#ifndef DOQUBOOKDEAMON_HPP
#define DOQUBOOKDEAMON_HPP

#include <DoQuBook/DoQuBook_global.hpp>

#include <DoQuBook/DoQuBookApp.hpp>
#include <DoQuBook/TaskService.hpp>
#include <DoQuBook/TempImageService.hpp>
#include <DoQuBook/ApplicationContext.hpp>
#include <DoQuBook/PluginLoader.hpp>
#include <DoQuBook/Repository.hpp>
#include <DoQuBook/Exceptions.hpp>
#include <QThread>

#include <DoQuBook/AlgorithmOnTask.hpp>



#include <signal.h>
#include <stdlib.h>
#include <stdio.h>

namespace DoQuBook
{

    class DoQuBookSHARED_EXPORT DoQuBookDeamon : public DoQuBookApp
    {
        public:
            DoQuBookDeamon (QCoreApplication & app,
                            const QString & orgName,
                            const QString & appName,
                            const QString & exeName = "");

        public :
            void setStopped (bool s) {
                stopped = s;
            }

            void unregister ();

        protected:

            virtual QList<ProgramParameter> paramsAndDescriptions();
            virtual void runApp (QMap<QString, QString> args );
            virtual void registerDaemon (QMap<QString, std_shared_ptr<AlgorithmOnTask>::type > &algos, DaemonServicePtr daemonService, QStringList & executors);

        private :

            bool stopped;
            RepositoryPtr repo;
            Daemon _token;

    };

}

#endif // DOQUBOOKDEAMON_HPP
