#ifndef DOQUBOOKPLUGINPARAMSDIALOG_HPP
#define DOQUBOOKPLUGINPARAMSDIALOG_HPP

#include <QDialog>
#include <DoQuBook/AlgorithmOnTask.hpp>
#include <DoQuBook/DoQuBook_global.hpp>
#include <QGridLayout>


namespace DoQuBook {

namespace gui {

class DoQuBookSHARED_EXPORT DoQuBookPluginParamsDialog : public QDialog
{
    Q_OBJECT
public:
    explicit DoQuBookPluginParamsDialog(std_shared_ptr<AlgorithmOnTask>::type plugin, QWidget *parent = 0);
    
signals:
    
public slots:
    void dispose();
    void setFile();
    void parameterFieldChanged(QString);

    void refreshGui(QVariantMap &m);
    
public :
    QVariantMap getParams() {return _parameters;}

private :
    QGridLayout * _layout;
    QVariantMap _parameters;
    std_shared_ptr<AlgorithmOnTask>::type _plugin;

};

}
}

#endif // DOQUBOOKPLUGINPARAMSDIALOG_HPP
