#ifndef EXECUTORSERVICE_HPP
#define EXECUTORSERVICE_HPP

#include <DoQuBook/DoQuBook_global.hpp>

#include <QSharedPointer>
#include <DoQuBook/Executor.hpp>
#include <DoQuBook/DaemonService.hpp>

namespace DoQuBook
{

    class ExecutorService;
    typedef QSharedPointer<ExecutorService> ExecutorServicePtr;


    class DoQuBookSHARED_EXPORT ExecutorService
    {
        public:
            ExecutorService();
            virtual ~ExecutorService();

            virtual void add (ExecutorPtr & task) = 0;
            virtual ExecutorPtr get (const QString & id) = 0;

            virtual QList<QString> getAll () = 0;

            virtual bool del (ExecutorPtr & task) = 0;
            virtual void update (ExecutorPtr & task) = 0;

    };

}
#endif // EXECUTORSERVICE_HPP
