#ifndef LAYOUTEXTRACTOR_HPP
#define LAYOUTEXTRACTOR_HPP



#include <DoQuBook/DoQuBook_global.hpp>
#include <DoQuBook/Region.hpp>
#include <DoQuBook/PluginBase.hpp>
#include <DoQuBook/Layout.hpp>

class DoQuBookSHARED_EXPORT LayoutExtractor : public PluginBase
{
    public:


        virtual ~LayoutExtractor(){}

        // --- To be implemented //
        virtual QString organisationName () = 0;
        virtual QString description () = 0;
        virtual QString algorithmName () = 0;
        virtual QString version() = 0;
        virtual DoQuBook::LayoutPtr extract (const QImage & image, const QVariantMap & params = QVariantMap() ) = 0;
        // --- //

//        virtual QList<DoQuBook::ExecutorParameterPtr> parameters () {
//            QList<DoQuBook::ExecutorParameterPtr> params;
//            return params;
//        }

        virtual QString pluginType () {
            return "LayoutExtractor";
        }

        virtual QString returnType() {
            return "Layout";
        }

//        virtual QList<DoQuBook::ExecutorParameterPtr> methodParameters() {
//            QList<DoQuBook::ExecutorParameterPtr> params;
//            params << DoQuBook::ExecutorParameter::create ("image", "Image", true);
//            return params;
//        }

//        virtual QVariant compute (const QVariantMap & pluginMethodParams, const QVariantMap & params = QVariantMap() ) {
//            qDebug() << "Binarizing !!! ";
//            QImage image = pluginMethodParams["image"].value<QImage>();
//            return binarize (image, params);
//        }

};


typedef std_shared_ptr<LayoutExtractor>::type LayoutExtractorPtr;

#define LayoutExtractor_iid "fr.labri.doqubook.LayoutExtractor"

Q_DECLARE_INTERFACE (LayoutExtractor, LayoutExtractor_iid)
#endif // LAYOUTEXTRACTOR_HPP
