#include "PageCollectionService.hpp"

using namespace DoQuBook;

#include <algorithm>

//#include <QGlobal.h>
#include <QTime>

int randInt(int low, int high)
{
  // Random number between low and high
  return qrand() % ((high + 1) - low) + low;
}


PageRandomSplitedSets::PageRandomSplitedSets (meta_iterator<PagePtr>::IteratorPtr it, int percentInFirstSet)
{
  QTime time = QTime::currentTime();
  qsrand((uint)time.msec());

  QList<PagePtr> allPages;
  while (it->hasNext() ) {
    PagePtr p = it->next();
    allPages.append (p);
  }
  //std::random_shuffle (allPages.begin(), allPages.end() );
  int nbInFirstSet = (percentInFirstSet * allPages.size() ) / 100;

  QList<int> selectedIndexes;
  QList<PagePtr> firstSet;
  for (int i = 0; i <= nbInFirstSet; i++) {
    int randomIndex = -1;
    do {
        randomIndex = randInt(0,allPages.size()-1);
    } while(randomIndex == -1 || selectedIndexes.contains(randomIndex));
    selectedIndexes << randomIndex;
    firstSet.append (allPages.at (randomIndex));
  }

  QList<PagePtr> secondSet;
  for (int i = 0; i < allPages.size(); i++) {
    if(!selectedIndexes.contains(i))
      secondSet.append (allPages.at (i) );
  }

  OnQListPageIteratorPtr itF (new OnQListPageIterator (firstSet) );
  firstSetIt = itF;

  OnQListPageIteratorPtr itS (new OnQListPageIterator (secondSet) );
  secondSetIt = itS;
}

PageRandomSplitedSets::~PageRandomSplitedSets()
{
}
