#ifndef PIXELFEATURES_HPP
#define PIXELFEATURES_HPP

#include <DoQuBook/SimpleMarshallable.hpp>
#include <DoQuBook/DoQuBook_global.hpp>

#include <QSharedPointer>
#include <DoQuBook/WebClient.hpp>


namespace DoQuBook {


  /*class PixelFeatures;
  typedef QSharedPointer<PixelFeatures> PixelFeaturesPtr;*/

  class DoQuBookSHARED_EXPORT PixelFeatures /*: public SimpleMarshallable*/ {
      //Q_OBJECT

    public:
      PixelFeatures() : m_id (-1) {}

      PixelFeatures(const int &x, const int &y, const QList<double> &features)
        : m_id (-1), m_x(x), m_y (y), m_features (features) {}

      //MARSHALLABLE_CREATE_FONCTIONS (PixelFeatures)
      /*static PixelFeaturesPtr create(const int &x, const int &y, const QList<double> &features)
      {
        PixelFeaturesPtr ptr (new PixelFeatures(x,y,features));
        ptr->_this = ptr.toWeakRef();
        return ptr;
      }*/

      int getId() const;
      int getX() const;
      int getY() const;
      QList<double> getFeatures() const;

    public /*slots*/:
      void setId(int arg);
      void setX(int arg);
      void setY(int arg);
      void setFeatures(QList<double> arg);

    /*signals:
      void idChanged(int arg);
      void xChanged(int arg);
      void yChanged(int arg);
      void featuresChanged(QList<double> arg);
      */

    protected:
      //Q_PROPERTY(int id READ getId WRITE setId NOTIFY idChanged)
      //Q_PROPERTY(int x READ getX WRITE setX NOTIFY xChanged)
      //Q_PROPERTY(int y READ getY WRITE setY NOTIFY yChanged)

      //Q_PROPERTY (QList<double> features READ getFeatures WRITE setFeatures NOTIFY featuresChanged)
      //MARSHALLABLE_QTLIST (QList, double, features)
      //MARSHALLABLE_ACTIV_1LIST (features, m_features)

      private :

        int m_id;
        int m_x;
        int m_y;
        QList<double> m_features;
  };

  class PixelFeaturesList;
  typedef QSharedPointer<PixelFeaturesList> PixelFeaturesListPtr;

  class DoQuBookSHARED_EXPORT PixelFeaturesList : public SimpleMarshallable {
      Q_OBJECT
    public :
      PixelFeaturesList () {}
      virtual ~PixelFeaturesList () {}
      MARSHALLABLE_CREATE_FONCTIONS (PixelFeaturesList)
      void add (const int &x, const int &y, const QList<double> &features)  {
        m_feats << PixelFeatures(x,y, features);
      }

      QList<PixelFeatures> getFeats() const
      {
        return m_feats;
      }

    public slots:

      virtual void write (QTextStream &out) {
        foreach (const PixelFeatures & f, m_feats) {
          out << f.getX() << "," << f.getY();
          foreach (const double &d, f.getFeatures()) {
            out << "," << d;
          }
          out << "\n";
        }

      }

      virtual QVariantMap serialize() {
        QVariantMap result;
        WebClient wc;

        const QMetaObject * metaobject = this->metaObject();
        if (!ignoredProperties().contains ("@property.type") ) {
            result["@property.type"] = metaobject->className();
        }

        QFile file("./features.txt");
        file.open(QIODevice::WriteOnly | QIODevice::Text);

        //QByteArray a; //--
        //QTextStream out (&a); //--
        QTextStream out (&file);
        write(out);

        //file.write(a);

        return result;
      }

      void setFeats(QList<PixelFeatures> arg)
      {
          m_feats = arg;
      }


    protected :
      Q_PROPERTY(QList<PixelFeatures> feats READ getFeats WRITE setFeats)
      //MARSHALLABLE_MLIST (QList, PixelFeatures, feat)
      //MARSHALLABLE_ACTIV_1LIST (feat, m_feats)

    private :
      QList<PixelFeatures> m_feats;
  };
}

Q_DECLARE_METATYPE ( DoQuBook::PixelFeatures* )
Q_DECLARE_TYPEINFO(DoQuBook::PixelFeatures*, Q_MOVABLE_TYPE);

#endif // PIXELFEATURES_HPP
