#ifndef PLUGINBASE_HPP
#define PLUGINBASE_HPP

#include <DoQuBook/DoQuBook_global.hpp>


#ifdef Q_WS_WIN
#   ifdef plugin_LIBRARY
#       ifndef plugin_EXPORT
#           define plugin_EXPORT Q_DECL_EXPORT
#       endif
#   else
#       ifndef plugin_EXPORT
#           define plugin_EXPORT Q_DECL_IMPORT
#       endif
#   endif
#else
#   define plugin_EXPORT
#endif


#ifdef HAVE_CPP11
#include <memory>
template <class T>
struct std_shared_ptr {
    typedef std::shared_ptr<T> type;
};
#else
#include <tr1/memory>
template <class T>
struct std_shared_ptr {
    typedef std::tr1::shared_ptr<T> type;
};

#endif

#include <QObject>

class DoQuBookSHARED_EXPORT PluginBase : public QObject
{
      Q_OBJECT
    public:
        PluginBase () : QObject (0) {}
        PluginBase (QObject * parent) : QObject(parent) {}
        virtual ~PluginBase () {}

        virtual QString organisationName () = 0;
        virtual QString description () = 0;
        virtual QString algorithmName () = 0;
        virtual QString version() = 0;
        virtual QString pluginType () = 0;
        virtual QString returnType() = 0;
        virtual QString pluginId() { return organisationName()+"."+algorithmName()+"."+version(); }
};

typedef std_shared_ptr<PluginBase>::type PluginBasePtr;

#endif // PLUGINBASE_HPP
