#ifndef REGIONEXTRACTOR_HPP
#define REGIONEXTRACTOR_HPP

#include <DoQuBook/DoQuBook_global.hpp>

#include <DoQuBook/Region.hpp>
#include <DoQuBook/PluginBase.hpp>
#include <QList>



class DoQuBookSHARED_EXPORT RegionExtractor : public PluginBase
{
  public:
    RegionExtractor();

    virtual QString pluginType () {return "RegionExtractor";}

    virtual QString returnType() {return "Void";}

    virtual void regions (const QImage & image) = 0;

    virtual void runProcesors (QList<DoQuBook::RegionPointProcessorPtr> &processors, const QVariantMap & parameters = QVariantMap() ) = 0;

    DoQuBook::RegionListPtr extractRegions(const QImage & image) {
      QList<DoQuBook::RegionPointProcessorPtr> processors;
      DoQuBook::ScanLineExtractorPtr extractorFromImage (new DoQuBook::RegionsExtractor);
      processors << extractorFromImage;
      this->regions(image);
      this->runProcesors(processors);
      DoQuBook::RegionListPtr extractedRegions = extractorFromImage->getRegions();
      return extractedRegions;
    }
};


typedef std_shared_ptr<RegionExtractor>::type RegionExtractorPtr;

#define RegionExtractor_iid "fr.labri.doqubook.RegionExtractor"

Q_DECLARE_INTERFACE (RegionExtractor, RegionExtractor_iid)


#endif // REGIONEXTRACTOR_HPP
