#ifndef REGIONFEATURES_HPP
#define REGIONFEATURES_HPP


#include <DoQuBook/SimpleMarshallable.hpp>
#include <DoQuBook/DoQuBook_global.hpp>

#include <QSharedPointer>

#include <DoQuBook/Region.hpp>

namespace DoQuBook {

  class RegionFeatures;
  typedef QSharedPointer<RegionFeatures> RegionFeaturesPtr;

  class DoQuBookSHARED_EXPORT RegionFeatures : public SimpleMarshallable {
      Q_OBJECT
    public:
      RegionFeatures();
      RegionPtr region() const;
      void setRegion(const RegionPtr& region);
      QList<double> features() const;
      void setFeatures(const QList<double>& features);

    private :
      RegionPtr _region;
      QList<double> _features;
    public :
      MARSHALLABLE_CREATE_FONCTIONS (RegionFeatures)

  };

  class RegionFeaturesList;
  typedef QSharedPointer<RegionFeaturesList> RegionFeaturesListPtr;

  class DoQuBookSHARED_EXPORT RegionFeaturesList : public SimpleMarshallable {
      Q_OBJECT
    public:
      RegionFeaturesList();

      QList<RegionFeaturesPtr> features() const;
      void setFeatures(const QList<RegionFeaturesPtr>& features);

      void add (const RegionFeaturesPtr& regionFeats);

    private :
      QList<RegionFeaturesPtr> _features;
    public :
      MARSHALLABLE_CREATE_FONCTIONS (RegionFeaturesList)
  };

}
#endif // REGIONFEATURES_HPP
