#ifndef REGIONFEATURESLISTCOMPUTER_HPP
#define REGIONFEATURESLISTCOMPUTER_HPP



#include <DoQuBook/DoQuBook_global.hpp>

#include <DoQuBook/RegionFeatures.hpp>
#include <DoQuBook/PluginBase.hpp>
#include <QList>


class DoQuBookSHARED_EXPORT RegionFeaturesListComputer : public PluginBase
{
  public:
    RegionFeaturesListComputer( ) {}
    virtual ~RegionFeaturesListComputer(){}


    virtual DoQuBook::RegionFeaturesListPtr extract (const QImage &image, DoQuBook::RegionListPtr& regions, const QVariantMap & parameters = QVariantMap() ) = 0;

    // From PluginBase
    virtual QString pluginType () {return "RegionFeaturesListComputer";}
    virtual QString returnType() {return "RegionFeaturesList";}
};

typedef std::tr1::shared_ptr<RegionFeaturesListComputer> RegionFeaturesListComputerPtr;

#define RegionFeaturesListComputer_iid "fr.labri.doqubook.RegionFeaturesListComputer"

Q_DECLARE_INTERFACE (RegionFeaturesListComputer, RegionFeaturesListComputer_iid)



#endif // REGIONFEATURESLISTCOMPUTER_HPP
