#ifndef REMOTEPLUGINFACTORY_H
#define REMOTEPLUGINFACTORY_H

#include <QObject>
#include <DoQuBook/Repository.hpp>
#include <DoQuBook/Executor.hpp>

#include <DoQuBook/PluginFactory.hpp>

namespace DoQuBook
{



    /**
     * @brief The RemotePluginFactory class builds a plugin proxy (ie: distant plugins).
     * It needs to be implemented to specify whitch plugin to build \see DBWebBinarizerRemoteProxy::BinarizerRemotePluginFactory
     */
    class RemotePluginFactory : public PluginFactory
    {
        public :
            RemotePluginFactory() {}

            virtual ~RemotePluginFactory() {}

            virtual bool accepts (RepositoryPtr repo, ExecutorPtr exec) = 0;

            void setup (RepositoryPtr repo, ExecutorPtr exec) {
                m_repo = repo;
                m_exec = exec;
            }

            virtual QObject * build() = 0;
            virtual void unLoad()  = 0;
            virtual RemotePluginFactory * clone() = 0;

        protected :
            RepositoryPtr m_repo;
            ExecutorPtr m_exec;
    };

}


#endif // REMOTEPLUGINFACTORY_H
