#include "RestFileAttachment.hpp"

#include <DoQuBook/WebClient.hpp>

#include <DoQuBook/Exceptions.hpp>

using namespace DoQuBook;


void RestFileAttachment::save (QFile & outFile) const
{
    if (!outFile.open (QIODevice::WriteOnly | QIODevice::Text) ) {
        throw MessageException ("could not ope file !");
    }

    WebClient wc;
    wc.setContentType (WebClient::JSON);
    QUrl url (m_url);
    QByteArray data = wc.sendSynchronous (url, WebClient::GET, "", "");

    QTextStream out (&outFile);
    out << data;
}

void RestFileAttachment::save (const QString & fileName) const
{
    QFile out (fileName);
    save (out);
}

void RestFileAttachment::save() const
{
    save (getFileName() );
}
