#ifndef RESTFILEATTACHMENT_HPP
#define RESTFILEATTACHMENT_HPP

#include <DoQuBook/DoQuBook_global.hpp>
#include <QObject>

#include <DoQuBook/Marshallable.hpp>
#include <DoQuBook/SimpleMarshallable.hpp>

#include <QSharedPointer>
#include <DoQuBook/Config.hpp>

#include <QUrl>
#include <QFile>

namespace DoQuBook
{

    class RestFileAttachment;
    typedef QSharedPointer<RestFileAttachment> RestFileAttachmentPtr;


    class DoQuBookSHARED_EXPORT RestFileAttachment : public SimpleMarshallable
    {
            Q_OBJECT
            Q_PROPERTY (QString fileName READ getFileName WRITE setFileName NOTIFY fileNameChanged)
            Q_PROPERTY (QString url READ getUrl WRITE setUrl NOTIFY urlChanged)

        public:
            MARSHALLABLE_CREATE_FONCTIONS (RestFileAttachment)

            void save () const;
            void save (const QString & fileName) const;
            void save (QFile & outFile) const;



            QString getFileName() const {
                return m_fileName;
            }

            QString getUrl() const {
                return m_url;
            }

        signals:

            void fileNameChanged (QString arg);

            void urlChanged (QString arg);

        public slots:

            void setFileName (QString arg) {
                if (m_fileName != arg) {
                    m_fileName = arg;
                    emit fileNameChanged (arg);
                }
            }
            void setUrl (QString arg) {
                if (m_url != arg) {
                    m_url = arg;
                    emit urlChanged (arg);
                }
            }

        private :
            QString m_fileName;
            QString m_url;

    };

}
#endif // RESTFILEATTACHMENT_HPP
