# Find DoQuBook - 
#
# This module defines
#  DoQuBook_FOUND - whether the DoQuBook library was found
#  DoQuBook_LIBRARIES - the DoQuBook library
#  DoQuBook_INCLUDE_DIR - the include path of the DoQuBook library
#

if (DoQuBook_INCLUDE_DIR AND DoQuBook_LIBRARIES)

  # Already in cache
  set (DoQuBook_FOUND TRUE)

else (DoQuBook_INCLUDE_DIR AND DoQuBook_LIBRARIES)

  if (NOT WIN32)
  	if(NOT APPLE)
    # use pkg-config to get the values of DoQuBook_INCLUDE_DIRS
    # and DoQuBook_LIBRARY_DIRS to add as hints to the find commands.
	    include (FindPkgConfig)
    	pkg_check_modules (PC_DoQuBook DoQuBook>=1.0)
    endif(NOT APPLE)
    IF(APPLE)
	# We search for Frameworks
  		INCLUDE(CMakeFindFrameworks)
	  	CMAKE_FIND_FRAMEWORKS(DoQuBook)
	ENDIF(APPLE)
  endif (NOT WIN32)

message("Here")

  find_library (DoQuBook_LIBRARIES
    NAMES
    DoQuBook
    PATHS
    ${PC_DoQuBook_LIBRARY_DIRS}
    ${DoQuBook_FRAMEWORKS}
    ${LIB_INSTALL_DIR}    
  )

  find_path (DoQuBook_INCLUDE_DIR
    NAMES
    DoQuBook/Book.hpp
    PATHS
    ${PC_DoQuBook_INCLUDE_DIRS}
    ${INCLUDE_INSTALL_DIR}
    ${DoQuBook_FRAMEWORKS}
  )

	message(${DoQuBook_LIBRARIES})
	message(${DoQuBook_INCLUDE_DIR})

  include(FindPackageHandleStandardArgs)
  find_package_handle_standard_args(DoQuBook DEFAULT_MSG DoQuBook_LIBRARIES DoQuBook_INCLUDE_DIR)

endif (DoQuBook_INCLUDE_DIR AND DoQuBook_LIBRARIES)
