macro(dqb_package NAME)

############################################
# cpack rules
set(CPACK_PACKAGE_NAME ${NAME})

set(CPACK_PACKAGE_VENDOR ${${NAME}_VENDOR})
set(${NAME}_VERSION ${${NAME}_MAJOR_VERSION}.${${NAME}_MINOR_VERSION}.${${NAME}_PATCH_VERSION})
SET(CPACK_PACKAGE_VERSION "${${NAME}_VERSION}")
SET(CPACK_PACKAGE_VERSION_MAJOR "${${NAME}_MAJOR_VERSION}")
SET(CPACK_PACKAGE_VERSION_MINOR "${${NAME}_MINOR_VERSION}")
SET(CPACK_PACKAGE_VERSION_PATCH "${${NAME}_PATCH_VERSION}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY ${NAME})
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${${NAME}_DESCRIPTION})
 
 if(WIN32)
	set(CPACK_NSIS_PACKAGE_NAME "${NAME}")
	set(CPACK_NSIS_DISPLAY_NAME "${NAME}")
	set(CPACK_NSIS_MODIFY_PATH "ON")
	set(CPACK_PACKAGE_EXECUTABLES "${NAME}" "${NAME}")
	set(CPACK_NSIS_MENU_LINKS "labri.digidoc.com" "Homepage for ${EWS_APP_NAME}")
	set(CPACK_NSIS_INSTALLED_ICON_NAME bin\\\\${NAME}.exe)
 endif()

IF(UNIX AND NOT APPLE)
	SET(CPACK_GENERATOR "DEB")
	SET(CPACK_DEBIAN_PACKAGE_MAINTAINER ${${NAME}_AUTHOR})
	SET(CPACK_PACKAGE_CONTACT "digidoc@gmail.com")
	Set(CPACK_PACKAGING_INSTALL_PREFIX /usr/local)
	IF(NOT DEFINED ${NAME}_DEB_DEPENDS)
		SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libdoqubook-dev")
	ENDIF(NOT DEFINED ${NAME}_DEB_DEPENDS)
	IF(DEFINED ${NAME}_DEB_DEPENDS)
		SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libdoqubook-dev,${${NAME}_DEB_DEPENDS}")
	ENDIF(DEFINED ${NAME}_DEB_DEPENDS)

	SET(CPACK_DEBIAN_PACKAGE_SECTION "devel")

	SET(SERVER sd-22392.dedibox.fr)
	SET(SERVER_REPO_BIN_PATH /var/www/digidoc-repo/binary/)
	SET(SERVER_REPO_PATH /var/www/digidoc-repo/)
	SET(ON_SERVER_USERNAME zoolonly)

	message(=> New target : deploydeb${NAME})
	ADD_CUSTOM_TARGET(deploydeb${NAME}
		 COMMAND ${CMAKE_COMMAND} -E echo "Deploying Generated Deb Files..."
		 COMMAND ${CMAKE_COMMAND} -E echo "  --- to :" ${SERVER}:${SERVER_REPO_PATH}
		 COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/../../Tools/publishDebs.sh
		 COMMAND ${CMAKE_COMMAND} -E echo "Done."
		 WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	)
ENDIF(UNIX AND NOT APPLE)
 
# on utilise cpack : "cpack -G DragNDrop CPackConfig.cmake" sur mac os x
# le CPackConfig.cmake est crÃ©er par un premier cmake
# Command osx /Applications/CMake\ 2.8-1.app/Contents/bin/cpack -G DragNDrop CPackConfig.cmake
#SET(CPACK_GENERATOR "DragNDrop")
#set(CPACK_BINARY_DRAGNDROP ON)

if(APPLE)
if(APPLE_ZIP_PACKAGE_NAME)
	set(ZIP_NAME ${APPLE_ZIP_PACKAGE_NAME})
	set(ZIP_VERSION ${APPLE_ZIP_PACKAGE_VERSION})
endif()
if(NOT APPLE_ZIP_PACKAGE_NAME) 
	set(ZIP_NAME ${NAME})
	set(ZIP_VERSION ${${NAME}_VERSION})
endif()
add_custom_command(TARGET package
	COMMAND ${CMAKE_COMMAND} -E copy ../../../../Tools/macx-install-plugin.sh ${CMAKE_BINARY_DIR}
	COMMAND ../../../../Tools/package_plugin.sh ${CMAKE_BINARY_DIR}/${ZIP_NAME}.${ZIP_VERSION}.zip ${CMAKE_BINARY_DIR}/plugins/lib${NAME}.dylib ${CMAKE_BINARY_DIR}
)
endif(APPLE)

if(NOT APPLE) # package is replaced by custom script on apple.
include(CPack)
endif()

endmacro(dqb_package)