
############################################################################
# Documentation avec Doxygen
############################################################################
macro(doxygen PROJECT_NAME)
FIND_PACKAGE(Doxygen)

IF (DOXYGEN_FOUND AND EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)

message("==> New documentation target : doc${PROJECT_NAME}")
MAKE_DIRECTORY(${CMAKE_SOURCE_DIR}/doc/)
SET(OUTPUT_DIRECTORY   ${CMAKE_SOURCE_DIR}/doc/${PROJECT_NAME})
SET(INPUT ${CMAKE_CURRENT_SOURCE_DIR})
SET(OUTPUT_LANGUAGE English)
SET(BUILD_DIRS "${CMAKE_CURRENT_BINARY_DIR} tests")

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
               ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
               @ONLY)

SET(documentationFolder ${PROJECT_NAME})
SET(documentationTarget doc${PROJECT_NAME})
ADD_CUSTOM_TARGET(doc${PROJECT_NAME}
 COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
 COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
 COMMAND ${CMAKE_COMMAND} -E echo "Done."
 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

ENDIF (DOXYGEN_FOUND AND EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
endmacro(doxygen)