
###########################################################################
###########################################################################
###########################################################################
##### DoQuBook Library
###########################################################################
###########################################################################
###########################################################################

macro(doqubook_library NAME HEADERS MOC_HEADERS SOURCES LIBS)

SET(LIBRARY_OUTPUT_PATH "${CMAKE_BINARY_DIR}/libs")

dqb_prepare_target(${NAME} "${HEADERS}" "${MOC_HEADERS}" "${SOURCES}" "${LIBS}")

############################################
# the target
ADD_LIBRARY(${NAME} SHARED ${ALL_SOURCES})
dqb_target_link_libraries(${NAME})

############################################
# installation rules
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${NAME}.pc.in
               ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.pc
               @ONLY)

INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.pc DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig)

INSTALL_FILES(/${CMAKE_ROOT}/Modules/ FILES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Find${NAME}.cmake)

SET(ALL_HEADERS ${MOC_HEADERS} ${HEADERS})
SET_TARGET_PROPERTIES(${NAME}
    PROPERTIES
    FRAMEWORK FALSE
    PUBLIC_HEADER "${ALL_HEADERS}"
    VERSION "${${NAME}_VERSION}"
)

INSTALL(TARGETS ${NAME}
    PUBLIC_HEADER DESTINATION include/${NAME}
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
)

##### Packaging
dqb_package(${NAME})

############################################
doxygen(${NAME})

endmacro(doqubook_library)