#include <DoQuBook/Book.hpp>
#include <DoQuBook/Page.hpp>
#include <QImage>
#include <QDir>
#include <QDebug>

using namespace DoQuBook;

int main(int argc, char *argv[])
{
    if(argc == 2)
    {
        Book book;
        QString directoryPath = argv[1];
        QDir directory(directoryPath);
        directory.setFilter(QDir::NoDotAndDotDot | QDir::Files);

        book.setName(directory.dirName());

        QStringList pathList;
        int cpt=1;
        qDebug() << "files found :";
        foreach(QFileInfo fileInfo, directory.entryInfoList())
        {
            pathList.append(fileInfo.fileName());

            qDebug() << fileInfo.absoluteFilePath();

            PagePtr ptr = Page::createPagePtr();
            ptr->setImage(fileInfo.fileName());
            book.addPage(ptr);
            ptr->setName(fileInfo.baseName());
            ptr->setNumber(cpt);
            cpt++;
        }

        qDebug() << "book name : "<< book.getName();
        qDebug() << "number of pages : "<< book.getPages().size();

        foreach(PagePtr page, book.getPages())
        {
            qDebug() << "page n"<< page->getNumber();
            qDebug() << "page name : "<<page->getName();
            QImage image = page->getImage();
            image.save(page->getImageFileName());
        }
    }

    return 0;
}
