#ifndef GENERICTESTPAGESERVICE_HPP
#define GENERICTESTPAGESERVICE_HPP

#include <QObject>
#include <DoQuBook/Repository.hpp>
#include <DoQuBook/ApplicationContext.hpp>
#include <DoQuBook/PluginLoader.hpp>

#include <Config.hpp>



#include <GenericCRUDServiceTest.hpp>


namespace DoQuBook {
  namespace TestsUtils {

    class GenericTestPageService : public QObject, public GenericCRUDServiceTest<Page, int>
    {
        Q_OBJECT
      public:
        explicit GenericTestPageService(QObject *parent = 0);

        GenericCRUDServiceTest<Page, int>::CRUDServicePtr buildService();
        QSharedPointer<Page> buildEntity();

        virtual void  modifyEntity(QSharedPointer<Page>  &e);
        virtual void verifyUpdated(QSharedPointer<Page>  &e);


      protected :
        virtual RepositoryPtr configureRepository() {}

      signals:

      private slots :
        void init();
        void testVerifyAddedPageinInit();
        void cleanup();

        void testGenericAddGetUpdateDel();

        void testFindByTags();


      public slots:

      protected :
        DoQuBook::RepositoryPtr repo;
        DoQuBook::PageServicePtr pageService;
        QList<int> addedPageIds;

    };

  }
}


#endif // GENERICTESTPAGESERVICE_HPP
