#ifndef TESTANNOTATION_HPP
#define TESTANNOTATION_HPP

#include <QtTest>
#include <DoQuBook/Annotation.hpp>
#include <assert.h>
#include <QDebug>
#include <QObject>

namespace Tests {

class TestAnnotation : public QObject{

    Q_OBJECT

public:

    TestAnnotation (DoQuBook::AnnotationPtr annotation)
        : QObject(NULL), m_annotation(annotation){}
protected:
    DoQuBook::AnnotationPtr m_annotation;

public slots:

    void setAnnotation(DoQuBook::AnnotationPtr annotation)
    {
        m_annotation = annotation;
    }

    void testGetSetName()
    {
        const QString annotationNewName ("newName");
        m_annotation->setName(annotationNewName);
        QVERIFY(m_annotation->getName() == annotationNewName);
    }

    void testAll()
    {
        testGetSetName();
    }
};

}
#endif //TESTANNOTATION_HPP
