#include "BinarizationShijian.hpp"
#include <QDebug>
#include <QtPlugin>

#include <cv.h>
#include <highgui.h>
#include <iostream>
#include <DoQuBook/DoQuBookOpenCVConverter.hpp>
#include <DoQuBook/ApplicationContext.hpp>

#include <QProcess>
#include <QDir>

#include <stdio.h>
#include <stdlib.h>

#include "Config.hpp"

//C:\Users\zoolonly\workspace\Digidoc\doqubookcpp\Plugins\Binarizers\BinarizationShijian\bin\binarization.exe BinarizationShijianTempImage.png BinarizationShijianOutImage.png"

using namespace DoQuBook;

using namespace Binarizers;

QString pathToExeFile = PATH_TO_SHIJIAN_EXE_DIR+"/binarization.exe";
QString pathToDLLs = PATH_TO_SHIJIAN_EXE_DIR;



bool copyDLL () {
    QDir dllDir (pathToDLLs);
    QStringList dllFilter;
    dllFilter << "*.dll";
    foreach(QFileInfo info, dllDir.entryInfoList(dllFilter)) {
        qDebug() << info.absoluteFilePath();
        QFile f (info.absoluteFilePath());
        f.copy(info.fileName());
    }
    return true;
}

QImage BinarizationShijian::binarize(const QImage & qimage, const QVariantMap &/*params*/)
{
    copyDLL();
    QString dir = ApplicationContext::instance()->getTempRepoPath();
    qDebug() << dir;
    QString inFileName = "BinarizationShijianTempImage.jpg";
    QString outFileName = "BinarizationShijianOutImage.png";
    qimage.save(inFileName);

#ifdef Q_WS_WIN
    QString xin = pathToExeFile.replace("/","\\");
#else
    QString xin = pathToExeFile;
#endif
    QFileInfo xinInfo (xin);

    if(!xinInfo.exists())
	throw MessageException("The Shijian binarization.exe is not installed, Please run sudo make install if possible");

    QString cl = xin+" "+inFileName+" "+outFileName;
    qDebug() << "CL :" << cl;
   // system(cl.toStdString().c_str());


    QStringList arguments;
#ifdef Q_WS_WIN
    arguments << "/c" << xin << inFileName << outFileName;
#else
    arguments << xin << inFileName << outFileName;
#endif

    QProcess *myProcess = new QProcess(this);
    qDebug() << "Runnning : " ;
#ifdef Q_WS_WIN
    myProcess->start("cmd.exe", arguments);
#else
    myProcess->start("wine", arguments);
#endif
    if (!myProcess->waitForStarted())
        throw MessageException("Could not start process : "+pathToExeFile);

    if (!myProcess->waitForFinished(-1))
        throw MessageException("Could not wait for process :"+pathToExeFile);

     QByteArray result = myProcess->readAll();

     qDebug() << "RESULT : " << result;

     if(myProcess->error() == QProcess::Crashed) {
        qDebug() << "ERROR : " << myProcess->errorString();
        throw MessageException (myProcess->errorString());
    }

    DoQuBookOpenCVConverter converteur;

    cv::Mat src = cv::imread(outFileName.toStdString());
    cv::Mat g_gray = cv::Mat::zeros(src.rows, src.cols, CV_8UC1);;
    cv::cvtColor( src, g_gray, CV_RGB2GRAY );

    cv::Mat out(g_gray.rows, g_gray.cols, cv::DataType<uchar>::type);

    int nl= out.rows; // number of lines
    int nc= out.cols ; // number of columns

    // is it a continous image?
    if (out.isContinuous())  {
        nc= nc*nl;
        nl= 1;  // it is now a 1D array
    }

    for (int j=0; j<nl; j++) {
        // pointer to first column of line j
        uchar* data= g_gray.ptr<uchar>(j);
        uchar* outData= out.ptr<uchar>(j);
        for (int i=0; i<nc; i++) {


            if( *(data) == 0)
                *outData++= 255; // only one channel
            else
                *outData++= 0;
            data++;
        }
    }

    QImage img = converteur.getQImage(out);
    return img;
    //return converteur.getQImage(out);
}


DQB_EXPORT_PLUGIN(BinarizationShijian)


