#include "OtsuBinarization.hpp"
//#include <QDebug>
#include <QtPlugin>

#include <cv.h>
#include <highgui.h>
//#include <iostream>
#include <DoQuBook/DoQuBookOpenCVConverter.hpp>

using namespace DoQuBook;

cv::RNG rng(12345);


QImage OtsuBinarization::binarize(const QImage &image, const QVariantMap &/*params*/)
{
    DoQuBookOpenCVConverter converteur;
    cv::Mat src = converteur.getCvMat(image);

    cv::Mat g_gray = cv::Mat::zeros(src.rows, src.cols, CV_8UC1);

    cv::cvtColor( src, g_gray, CV_BGR2GRAY );

    cv::threshold( g_gray, g_gray, 0, 255, CV_THRESH_OTSU  );
    
   return  converteur.getQImage(g_gray);
}

QList<ExecutorParameterPtr> OtsuBinarization::parameters()
{
    QList<DoQuBook::ExecutorParameterPtr> params;
    return params;
}

DQB_EXPORT_PLUGIN(OtsuBinarization)
