#include "TestBleedThroughDegradationModel.hpp"

#include <BleedThroughDegradationModel.hpp>
#include <DoQuBook/PluginLoader.hpp>
#include <QApplication>
#include "Config.hpp"

using namespace labri::DegradationModels;

TestBleedThroughDegradationModel::TestBleedThroughDegradationModel()
{
//    QString plugins_dir_path = qApp->applicationDirPath()+"/../plugins";
//    DoQuBook::PluginLoader::instance()->setPluginDirPath(plugins_dir_path);
}

void TestBleedThroughDegradationModel::testPluginCleanDocuments()
{

    BleedThroughDegradationModel plugin;
    QImage recto (DATA_DIR+"rectoClean.png");
    QImage verso (DATA_DIR+"versoClean.png");

    QVERIFY(!recto.isNull());
    QVERIFY(!verso.isNull());

    QVariantMap params;
    params ["verso"] = verso;
    params ["nb_iterations"] = 30;
    params ["optimized_old"] = false;

    QImage res = plugin.degradate(recto, params);
    QVERIFY(!res.isNull());
}


void TestBleedThroughDegradationModel::testPluginOldDocuments()
{
    BleedThroughDegradationModel plugin;
    QImage recto (DATA_DIR+"recto.png");
    QImage verso (DATA_DIR+"verso.png");

    QVERIFY(!recto.isNull());
    QVERIFY(!verso.isNull());

    QVariantMap params;
    params ["verso"] = verso;

    QImage res = plugin.degradate(recto, params);
    QVERIFY(!res.isNull());
		res.save("testPluginOldDocuments.png");
}

void TestBleedThroughDegradationModel::testWithAllParameters()
{
    BleedThroughDegradationModel plugin;
    QImage recto (DATA_DIR+"rectoClean.png");
    QImage verso (DATA_DIR+"versoClean.png");

    QVERIFY(!recto.isNull());
    QVERIFY(!verso.isNull());

    QVariantMap params;
    params ["verso"] = verso;
    params ["nb_iterations"] = 30;
    params ["optimized_old"] = false;
    params ["dt"] = 1.6;
    params ["sigma_b"] = 100;
    params ["sigma_ink"] = 51;

    QImage res = plugin.degradate(recto, params);
    QVERIFY(!res.isNull());

}


void TestBleedThroughDegradationModel::init()
{
}

void TestBleedThroughDegradationModel::cleanup()
{

}

QTEST_MAIN(TestBleedThroughDegradationModel)




