#include "SaltAndPeper.hpp"

/* If OpenCV is required, please change the CMakeLists.txt*/
#include <cv.h>
//#include <highgui.h>

//#include <iostream>
//#include <QDebug>

#include <DoQuBook/DoQuBookOpenCVConverter.hpp>

#include <QtPlugin>

using namespace DoQuBook;

QList<DoQuBook::ExecutorParameterPtr>  SaltAndPeper::parameters ()
{
  QList<DoQuBook::ExecutorParameterPtr> params;
  params << DoQuBook::ExecutorParameter::create("blackThd", "Number", true);
  params << DoQuBook::ExecutorParameter::create("whiteThd", "Number", true);
  return params;
}

QImage SaltAndPeper::degradate(const QImage & qimage, const QVariantMap &params)
{
  int blackThd;
  int whiteThd;
  if(params.contains("blackThd")) {
    blackThd = params["blackThd"].toInt();
  } else {
    blackThd = qrand() % ((50 + 1) - 1) + 1;
  }
  if(params.contains("whiteThd")) {
    whiteThd = params["whiteThd"].toInt();
  } else {
    whiteThd = qrand() % ((254 + 1) - 200) + 200;
  }

  DoQuBookOpenCVConverter converter;
  cv::Mat mat = converter.getCvMat(qimage);

  cv::Mat saltpepper_noise = cv::Mat::zeros(mat.rows, mat.cols,CV_8U);
  cv::randu(saltpepper_noise,0,255);

  // Generate Mask
  cv::Mat black = saltpepper_noise < blackThd;
  cv::Mat white = saltpepper_noise > whiteThd;

  cv::Mat saltpepper_img = mat.clone();
  // sets some of the matrix elements to s, according to the mask
  saltpepper_img.setTo(255,white);
  saltpepper_img.setTo(0,black);
  QImage saltQImage = converter.getQImage(saltpepper_img);
  return saltQImage;
}


DQB_EXPORT_PLUGIN(SaltAndPeper)
