#include "TestSaltAndPeper.hpp"

#include <SaltAndPeper.hpp>
#include <DoQuBook/PluginLoader.hpp>
#include <QApplication>
#include "Config.hpp"

#include <DoQuBook/ApplicationContext.hpp>

void TestSaltAndPeper::testPlugin()
{
    SaltAndPeper plugin;

    DoQuBook::RepositoryPtr repo = DoQuBook::ApplicationContext::instance()->getRepository("digidoc");
    DoQuBook::PageServicePtr srv = repo->getPageService();
    QImage testImage = srv->get(1)->getImage();
    Q_ASSERT(!testImage.isNull());
    for(int i = 0; i <= 5; i++) {
      QImage degradaedImage = plugin.degradate(testImage);
      Q_ASSERT(!degradaedImage.isNull());
      degradaedImage.save("degraded"+QString::number(i)+".png");
    }

}

void TestSaltAndPeper::init()
{
}

void TestSaltAndPeper::cleanup()
{
}

QTEST_MAIN(TestSaltAndPeper)
