#include "SampleLinkedParameters.hpp"

#include <cv.h>
#include <highgui.h>
#include <iostream>

#include <DoQuBook/DoQuBookOpenCVConverter.hpp>

#include <QDebug>
#include <QtPlugin>

#include <iostream>

#include "DoQuBook/ApplicationContext.hpp"
#include "DoQuBook/Repository.hpp"
#include "DoQuBook/PageCollectionService.hpp"
#include "DoQuBook/PageService.hpp"

using namespace DoQuBook;
using namespace labri;
using namespace DegradationModels;

QVariantMap SampleLinkedParameters::onParameterChanged(const QString &name, const QVariant &var) 
{
	QVariantMap parameters;
	if(name == "p1") {
			if(var.toDouble() > 100) 
				parameters["p1"] = 100;
			else 
				parameters["p1"] = var.toDouble();
				
			parameters["p2"] = 100-parameters["p1"].toDouble();
	}
	
	if(name == "p2") {
			if(var.toDouble() > 100)
				parameters["p2"] = 100;
			else 
				parameters["p2"] = var.toDouble();
				
			parameters["p1"] = 100-parameters["p2"].toDouble();
	}
	// Notify the new parameters values
	emit autoParametersCalculated(parameters);
	
	return parameters;
}

QImage SampleLinkedParameters::degradate(const QImage &recto, const QVariantMap &parameters)
{
		// degradation	
    DoQuBookOpenCVConverter converter;
    cv::Mat original = converter.getCvMat(recto);
   
		return converter.getQImage(original);

}
DQB_EXPORT_PLUGIN(SampleLinkedParameters)