#include "DeskewOCROpus.hpp"

#include <QDebug>
#include <QtPlugin>

#include <colib/checks.h>
#include <colib/colib.h>
#include <iulib/iulib.h>
#include <ocropus/ocropus.h>
#include <ocropus/glinerec.h>
#include <ocropus/ocr-deskew-rast.h>
#include <iostream>

#include <QImage>

using namespace iulib;
using namespace colib;
using namespace ocropus;
using namespace narray_ops;
using namespace glinerec;
using namespace std;

#define RAD_TO_DEG 57.3

QTransform DeskewOCROpus::deskewTransformation (const QImage &image)
{
    QTransform transform;
    //transform.translate(50, 50);
    /*transform.rotate(5);
    return transform;
    */

    QString filename = "tmp.png";
    image.save(filename);

    double angle = 0;

    init_ocropus_components();
    init_glclass();
    init_glfmaps();
    init_linerec();

    Pages pages;
    pages.parseSpec(filename.toStdString().c_str());

    if (pages.nextPage()) {
        bytearray page_binary;
        pages.getGray(page_binary);
        angle = estimate_skew_by_rast (page_binary)*RAD_TO_DEG;
    }

    transform.rotate(angle);
    return transform;
}


DQB_EXPORT_PLUGIN(DeskewOCROpus)
