#include "TestDeskewOCROpus.hpp"

#include <DeskewOCROpus.hpp>
#include <DoQuBook/PluginLoader.hpp>
#include <QApplication>
#include <math.h>
#include "Config.hpp"

#ifndef M_PI
   #define M_PI 3.14159265358979323846
#endif

void TestDeskewOCROpus::testPlugin()
{
    QString plugins_dir_path = qApp->applicationDirPath()+"/../plugins";
    DoQuBook::PluginLoader::instance()->setPluginDirPath(plugins_dir_path);
    
    DeskewOCROpus plugin;
    QImage testImage (DATA_DIR+"doc_propre.png");
    QVERIFY(!testImage.isNull());
    QTransform t = plugin.deskewTransformation ( testImage );

    qDebug() << t.dx();
    qDebug() << t.dy();
    qDebug() << acos(t.m11()) * 180.0 / M_PI;

    QTransform theTransform;
    theTransform.rotate(10);

    QImage testRotatedImage =  testImage.transformed(theTransform);
    t = plugin.deskewTransformation ( testRotatedImage );

    int angle = ceil(acos(t.m11()) * 180.0 / M_PI);
    int originalAngle = acos(theTransform.m11()) * 180.0 / M_PI;

    QVERIFY (angle == originalAngle);

    QImage transformed = testRotatedImage.transformed(t);
    transformed.save("Transformed.png");
    QVERIFY(!transformed.isNull());

}

void TestDeskewOCROpus::init()
{
}

void TestDeskewOCROpus::cleanup()
{
}

QTEST_MAIN(TestDeskewOCROpus)
