#include "TestFScoreImage.hpp"

#include <FScoreImage.hpp>
#include <DoQuBook/PluginLoader.hpp>
#include <QApplication>

void TestFScoreImage::testPlugin()
{
    QString plugins_dir_path = qApp->applicationDirPath()+"/../plugins";
    DoQuBook::PluginLoader::instance()->setPluginDirPath(plugins_dir_path);
    
     FScoreImage plugin;
     QImage truth (":/images/truth");
     QImage bad (":/images/bad");
     QImage lessBad (":/images/lessBad");

     double truthVsTruth = plugin.compare (truth, truth);
     QVERIFY(truthVsTruth == 1);

     double truthVsBad = plugin.compare (truth, bad);
     QVERIFY (truthVsBad == 0);
     double truthVslessBad = plugin.compare (truth, lessBad);
     QVERIFY (truthVsTruth > truthVslessBad);
     QVERIFY (truthVsBad < truthVslessBad);
}

void TestFScoreImage::init()
{
}

void TestFScoreImage::cleanup()
{
}

QTEST_MAIN(TestFScoreImage)
