#include "EqualizeHistogramOpenCV.hpp"

#include <cv.h>
#include <highgui.h>
#include <iostream>

#include <DoQuBook/DoQuBookOpenCVConverter.hpp>

#include <QDebug>
#include <QtPlugin>

using namespace DoQuBook;

QImage EqualizeHistogramOpenCV::filter(const QImage &image, const QVariantMap &/*params*/)
{
    DoQuBookOpenCVConverter converter;
    cv::Mat mat = converter.getCvMat(image);

    cv::Mat g_gray = cv::Mat::zeros(mat.rows, mat.cols, CV_8UC1);;
    cv::cvtColor( mat, g_gray, CV_RGB2GRAY );

    cv::Mat result;
    cv::equalizeHist(g_gray,result);

    return converter.getQImage(result);
}


DQB_EXPORT_PLUGIN(EqualizeHistogramOpenCV)
