#include "SharpenOpenCV.hpp"

#include <cv.h>
#include <highgui.h>
#include <iostream>

#include <DoQuBook/DoQuBookOpenCVConverter.hpp>

#include <QDebug>
#include <QtPlugin>

using namespace DoQuBook;


QImage SharpenOpenCV::filter(const QImage &qimage, const QVariantMap &/*params*/)
{
    DoQuBookOpenCVConverter converter;
    cv::Mat src = converter.getCvMat(qimage);

    cv::Mat result;
    // Construct kernel (all entries initialized to 0)
    cv::Mat kernel(3,3,CV_32F,cv::Scalar(0));

    // assigns kernel values
    kernel.at<float>(1,1)= 5.0;
    kernel.at<float>(0,1)= -1.0;
    kernel.at<float>(2,1)= -1.0;
    kernel.at<float>(1,0)= -1.0;
    kernel.at<float>(1,2)= -1.0;

    //filter the image
    cv::filter2D (src,result,src.depth(),kernel);

    return converter.getQImage(result);
}


DQB_EXPORT_PLUGIN(SharpenOpenCV)
