# - Try to find TESSERACT 
# Once done, it will define
#
# TESSERACT_FOUND - system has TESSERACT
# TESSERACT_INCLUDE_DIRS - TESSERACT include directories
# TESSERACT_DEFINITIONS - Compiler switches required for using TESSERACT
# TESSERACT_LIBRARIES - link these to use TESSERACT

#include(LibFindMacros)


FIND_PACKAGE(leptonica REQUIRED)



IF (TESSERACT_INCLUDE_DIRS AND TESSERACT_LIBRARIES)
   # in cache already
   SET(TESSERACT_FIND_QUIETLY TRUE)
ENDIF (TESSERACT_INCLUDE_DIRS AND TESSERACT_LIBRARIES)


IF (NOT WIN32)
  include(FindPkgConfig)
  pkg_check_modules(TESSERACT_PKGCONF tesseract)
  SET(TESSERACT_DEFINITIONS ${TESSERACT_DEFINITIONS} ${TESSERACT_PKGCONF_CFLAGS_OTHER})
ENDIF (NOT WIN32)


# Include dir
find_path(TESSERACT_INCLUDE_DIR
  NAMES ocrclass.h
  PATHS ${TESSERACT_PKGCONF_INCLUDE_DIRS})

# Library
find_library(TESSERACT_LIBRARY
  NAMES tesseract
  PATHS ${TESSERACT_PKGCONF_LIBRARY_DIRS})


#set(TESSERACT_PROCESS_INCLUDES TESSERACT_INCLUDE_DIR)
#set(TESSERACT_PROCESS_LIBS TESSERACT_LIBRARY)
#libfind_process(TESSERACT)


INCLUDE(FindPackageHandleStandardArgs)

# handle the QUIETLY and REQUIRED arguments and set TESSERACT_FOUND to TRUE if 
# all listed variables are TRUE
FIND_PACKAGE_HANDLE_STANDARD_ARGS(TESSERACT DEFAULT_MSG TESSERACT_LIBRARY TESSERACT_INCLUDE_DIR)

IF (TESSERACT_FOUND)
  set(TESSERACT_INCLUDE_DIRS ${leptonica_INCLUDE_DIR} ${TESSERACT_INCLUDE_DIR})
  set(TESSERACT_LIBRARIES ${leptonica_LIBRARY} ${TESSERACT_LIBRARY})
ENDIF (TESSERACT_FOUND)

message(${TESSERACT_INCLUDE_DIRS})
message(${TESSERACT_LIBRARIES})


MARK_AS_ADVANCED(TESSERACT_INCLUDE_DIRS TESSERACT_LIBRARIES)