# - Try to find leptonica 
# Once done, it will define
#
# leptonica_FOUND - system has leptonica
# leptonica_INCLUDE_DIRS - leptonica include directories
# leptonica_DEFINITIONS - Compiler switches required for using leptonica
# leptonica_LIBRARIES - link these to use leptonica

#include(LibFindMacros)



IF (leptonica_INCLUDE_DIRS AND leptonica_LIBRARIES)
   # in cache already
   SET(leptonica_FIND_QUIETLY TRUE)
ENDIF (leptonica_INCLUDE_DIRS AND leptonica_LIBRARIES)


IF (NOT WIN32)
  include(FindPkgConfig)
  pkg_check_modules(leptonica_PKGCONF leptonica)
  SET(leptonica_DEFINITIONS ${leptonica_DEFINITIONS} ${leptonica_PKGCONF_CFLAGS_OTHER})
ENDIF (NOT WIN32)


# Include dir
find_path(leptonica_INCLUDE_DIR
  NAMES watershed.h
  PATHS 
	${leptonica_PKGCONF_INCLUDE_DIRS}
	/usr/local/include/leptonica/
	)


# Library
find_library(leptonica_LIBRARY
  NAMES lept
  PATHS 
	${leptonica_PKGCONF_LIBRARY_DIRS}
	/usr/local/lib/
)


#set(leptonica_PROCESS_INCLUDES leptonica_INCLUDE_DIR)
#set(leptonica_PROCESS_LIBS leptonica_LIBRARY)
#libfind_process(leptonica)


INCLUDE(FindPackageHandleStandardArgs)

# handle the QUIETLY and REQUIRED arguments and set leptonica_FOUND to TRUE if 
# all listed variables are TRUE
FIND_PACKAGE_HANDLE_STANDARD_ARGS(leptonica DEFAULT_MSG leptonica_LIBRARY leptonica_INCLUDE_DIR)

#IF (leptonica_FOUND)
#  set(leptonica_INCLUDE_DIRS ${GIRLTOOLS_INCLUDE_DIRS} ${FFTW2_INCLUDE_DIRS} ${leptonica_INCLUDE_DIR})
#  set(leptonica_LIBRARIES ${GIRLTOOLS_LIBRARIES} ${FFTW2_LIBRARIES} ${leptonica_LIBRARY})
#ENDIF (leptonica_FOUND)


MARK_AS_ADVANCED(leptonica_INCLUDE_DIRS leptonica_LIBRARIES)