#include "TesseractCL.hpp"

#include <cv.h>
#include <highgui.h>
#include <iostream>

#include <DoQuBook/Exceptions.hpp>
#include <DoQuBook/DoQuBookOpenCVConverter.hpp>

#include <QDebug>
#include <QtPlugin>
#include <QProcess>
#include <QFile>

#include "Config.hpp"

using namespace DoQuBook;


QString TesseractCL::ocr(const QImage &image, const QVariantMap &params)
{
    QString imageFilePath = "tmpTesseractImg.tif";
    QString outFilePath = "out";
    image.save(imageFilePath);

    QString program = PATH_TO_TESSERACT;
    qDebug() << PATH_TO_TESSERACT;
    QStringList arguments;
    arguments <<  imageFilePath << outFilePath ;

    QProcess *myProcess = new QProcess;
    myProcess->start(program, arguments);
    myProcess->waitForFinished(-1);

    QFile file(outFilePath+".txt");
    if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
        throw MessageException ("IO error in TesseractCL plugin");

    QString ocr;
    while (!file.atEnd()) {
        QByteArray line = file.readLine();
        ocr+=line;
    }
    return ocr;
}


DQB_EXPORT_PLUGIN(TesseractCL)
