#ifndef SegmentationClusteringSameColorPixel_HPP
#define SegmentationClusteringSameColorPixel_HPP

#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseHistogram1D.hpp>
#include <girlTools/girlToolsImage.hpp>
#include <ise/iseQuantificationThresholderOtsu2T.hpp>
#include <ise/iseSegmentationContext.hpp>

#include <QDebug>

class SegmentationClusteringSameColorPixel : public ise::SegmentationClustering
{

public :
    SegmentationClusteringSameColorPixel(ise::SegmentationContext *segContext)
        : ise::SegmentationClustering (segContext)
    {
        m_image = segContext->getImage();
    }

    virtual void init(const girl::regionDeque &/*regions*/, int /*level*/=1) {}

    virtual void init(girl::region , int ) {}


    virtual bool same(const girl::point &p, girl::direction dir) {
        girl::point p2 = p;
        p2.move(dir);

        size_t pixelP1 = m_image->getPixel(p.x(),p.y())[0];
        size_t pixelP2 = m_image->getPixel(p2.x(),p2.y())[0];

        return pixelP1 == pixelP2;
    }

protected :
    size_t m_bleedThd;
    girl::tools::Image *m_image;
    std::vector<double> levels;
    size_t m_inkThd;
};
#endif // SegmentationClusteringSameColorPixel_HPP
