  #include <DoQuBook/RegionExtractor.hpp>

#include <PluginConfig.hpp>
#include <QColor>

#include <cv.h>
#include <highgui.h>

#include <DoQuBook/AlgorithmOnTask.hpp>


class plugin_EXPORT RegionExtractorOpenCVForeground : public RegionExtractor
{
    Q_OBJECT
    DQB_PLUGIN(RegionExtractor, "fr.labri.doqubook.RegionExtractor")

    virtual void regions(const QImage &image);

    virtual void runProcesors (QList<DoQuBook::RegionPointProcessorPtr> &processors, const QVariantMap &parameters = QVariantMap());


public :
    typedef std::vector < cv::Point > Shape;
    typedef std::vector <Shape> ShapeList;
    typedef std::vector<cv::Vec4i> Hierarchy;

protected :


    ShapeList list;
    Hierarchy hierachy;
    cv::Mat bin;
    cv::Mat src;
    QColor _color;
};
