#include "TestGaborFilters.hpp"

#include <GaborFilters.hpp>
#include <DoQuBook/PluginLoader.hpp>
#include <QApplication>
#include "Config.hpp"

#include <DoQuBook/ApplicationContext.hpp>


QString timeConversion(int msecs)
{
    QString formattedTime;

    int hours = msecs/(1000*60*60);
    int minutes = (msecs-(hours*1000*60*60))/(1000*60);
    int seconds = (msecs-(minutes*1000*60)-(hours*1000*60*60))/1000;
    int milliseconds = msecs-(seconds*1000)-(minutes*1000*60)-(hours*1000*60*60);

    formattedTime.append(QString("%1").arg(hours, 2, 10, QLatin1Char('0')) + ":" +
                         QString( "%1" ).arg(minutes, 2, 10, QLatin1Char('0')) + ":" +
                         QString( "%1" ).arg(seconds, 2, 10, QLatin1Char('0')) + ":" +
                         QString( "%1" ).arg(milliseconds, 3, 10, QLatin1Char('0')));

    return formattedTime;
}

void TestGaborFilters::testPlugin()
{
	/*Plugin loading*/
    //QString plugins_dir_path = qApp->applicationDirPath()+"/../plugins";
    //DoQuBook::PluginLoader::instance()->setPluginDirPath(plugins_dir_path);
    

  DoQuBook::PageServicePtr service = DoQuBook::ApplicationContext::instance()->getRepository("digidoc")->getPageService();
  QImage testImage = service->get(1)->getImage();

  GaborFilters plugin;
  QElapsedTimer   myTimer;
  qDebug() << "Computing gabor features";
  myTimer.start();
  DoQuBook::PixelFeaturesListPtr feats = plugin.extract(testImage);
  qDebug() << "     --> done in " << timeConversion(myTimer.elapsed());
  qDebug() << "Saving to out.csv";

  QFile file("./out.csv");
  file.open(QIODevice::WriteOnly | QIODevice::Text);
  QTextStream out(&file);

  out << "feats" << " ; " << "\n";


  // TODO : compile and test
  foreach(const DoQuBook::PixelFeatures &f, feats->getFeats()) {
    out << f.getX()  << " " << f.getY() << " " << f.getFeatures() << "\n";
  }
  qDebug() << "     --> done in " << timeConversion(myTimer.elapsed());
}

void TestGaborFilters::init()
{
}

void TestGaborFilters::cleanup()
{
}

QTEST_MAIN(TestGaborFilters)
