#include "GradientInterPixelComputer.hpp"

#include <DoQuBook/DoQuBookOpenCVConverter.hpp>
#include <ise/iseImageFeatureGradientInterPixel.hpp>

#include <QtPlugin>

using namespace DoQuBook;

QList<DoQuBook::ExecutorParameterPtr>  GradientInterPixelComputer::parameters ()
{
  QList<DoQuBook::ExecutorParameterPtr> params;
  //params << DoQuBook::ExecutorParameter::create("thd", "Double", true);
  return params;
}

DoQuBook::PixelFeaturesListPtr GradientInterPixelComputer::extract (const QImage &qimage, const QVariantMap & /*parameters*/)
{
  DoQuBookOpenCVConverter converter;
  cv::Mat src = converter.getCvMat(qimage);

  girl::tools::Image image (src);

  girl::toger tog(image.width(), image.height());

  ise::SegmentationContext segContext;
  segContext.setToger(&tog);
  segContext.setImage(&image);


  ise::ImageFeatureGradientInterPixel computer(&segContext);
  computer.compute();
  girl::shared_ptr<girl::tools::ImageFeature> img = computer.getImageFeature();

  DoQuBook::PixelFeaturesListPtr  feats = PixelFeaturesList::create();

  for (int i = 0; i < img->height(); ++i) {
    girl::tools::ImageFeature::type *buf = img->scanLine(i);

    for (int j = 0; j < img->width(); ++j) {
      QList<double> values;
      for(int k = 0; k < img->formatSize(); k++)
        values << buf[k];

      feats->add(i, j, values);
      buf += img->formatSize();
    }
  }

  return feats;
}


DQB_EXPORT_PLUGIN(GradientInterPixelComputer)
