#ifndef COLLECTIONUTILS_HPP
#define COLLECTIONUTILS_HPP

#include <QVector>
#include <cv.h>
#include <highgui.h>
#include <QDebug>


typedef QVector< QVector<int> > MatrixInt;

/// todo collections and collection items should be templated.
class CollectionUtils {

public :
static double mean(const QVector<size_t> &vector)
{
    if (vector.size() == 0)
        return 0;

    int s=0;
    foreach (size_t val, vector) {
        s+=val;
    }
    return s/vector.size();
}

static double trimedmean(const QVector<size_t> &vector)
{
    return mean(vector);
    /// Something is wrong with cleaned vectors
    /*
    if (vector.size() == 0)
        return 0;

    const int percent = 25;
    QVector<size_t> out (vector);
    qSort(out);
    int interval =  (percent*out.size()) / 100;
    size_t minValue = out.at(0+interval);
    size_t maxValue = out.at(out.size()-interval);

    int s=0;
    int nb = 0;
    foreach (size_t val, vector) {
        if(val > minValue && val < maxValue) {
            s+=val;
            nb++;
        }
    }
    return s/nb;
    */

}
static CvHistogram * convert(const QVector<size_t> &vector)
{
    int	hist_size[] = { vector.size() };
    float range[] = {0,vector.size()};

    float *ranges[] = {range};

    CvHistogram *histo = cvCreateHist(1, hist_size, CV_HIST_ARRAY, ranges, 1);
    for(int i = 0; i < vector.size() ; i++)
    {
        cvSetReal1D(histo->bins, i, vector.at(i));
        //std::cout << cvGetReal1D(histo->bins, i) << std::endl;
        //std::cout << histo->bins[0] << std::endl;
    }
    return histo;

}
static double stdDeviation(const QVector<size_t> &vector, double pMean = -1)
{
    if (vector.size() == 0)
        return 0;

    if (pMean == -1)
        pMean = mean (vector);

    double s=0;
    foreach (size_t val, vector) {
        s+=(val-pMean)*(val-pMean);
    }

    return sqrt((1.0/(double)vector.size()) * s);
}

static QList<size_t> normed(const QList<size_t>  &list){
    size_t max = *(std::max_element(list.begin(), list.end()));
    QList<size_t> out;
    foreach (size_t val, list) {
        out.push_back(val/max);
    }
    return out;
}

};


#endif // COLLECTIONUTILS_HPP
