#include "HorizontalRegistration.hpp"
#include <QDebug>

int getFisrtImportantBin (QVector<size_t> profile, int thd)
{
    int firstImportantBinIndex = 0;
    int currentBinValue = profile.at(0);
    int i = 0;
    while (i < profile.size() && currentBinValue <= thd) {
        i++;
        currentBinValue = profile.at(i);
    }
    firstImportantBinIndex = i;
    return firstImportantBinIndex;
}

int getLastImportantBin (QVector<size_t> profile, int thd)
{
    int firstImportantBinIndex = 0;
    int currentBinValue = profile.at(0);
    int i = profile.size();
    while (i > 0  && currentBinValue <= thd) {
        i--;
        currentBinValue = profile.at(i);
    }
    firstImportantBinIndex = i;
    return firstImportantBinIndex;
}

HorizontalRegistration::HorizontalRegistration()
{
}

int HorizontalRegistration::meanDx(Dtw::BinMatchList assocs, QVector<size_t> hProfile1, QVector<size_t> hProfile2)
{
    int binImp1 = getFisrtImportantBin (hProfile1, 200);
    int binImp2 = getLastImportantBin (hProfile2, 50);

    qDebug() << "hProfile1 : " << binImp1;
    qDebug() << "hProfile2 : " << binImp2;

    return binImp1 - (hProfile2.size() - binImp2);
}
