#include "HorizontalRunLenghtProfiler.hpp"
#include <iostream>

#include <QTextStream>
#include <QFile>

#include "ProfileThresholder.hpp"
#include "CollectionUtils.hpp"

HorizontalRunLenghtProfiler::HorizontalRunLenghtProfiler ()
{
    //m_pixelForImage = &(DoQuMeasures::Pixels::rouge);
    //m_img = new girl::tools::Image;
}

/*void HorizontalRunLenghtProfiler::computeProfile (girl::tools::Image *img)
{
    m_img = img;

    for (int j = 0; j< m_img->height() -1; j++) {
        int s = 0;
        for (int i = 0; i< m_img->width() -1; i++) {
            std::cout << m_img->getPixel(i,j)[0] << std::endl;
            if (m_img->getPixel(i,j)[0] >= m_thd0 && m_img->getPixel(i,j)[0] <= m_thd1) {
                s++;
            }
        }

        m_horizontalProfile.push_back(s);
    }


    for (int i = 0; i<= m_img->width(); i++) {
        int s = 0;
        for (int j = 0; j<= m_img->height(); j++) {
            if (m_img->getPixel(i,j)[0] >= m_thd0 && m_img->getPixel(i,j)[0] <= m_thd1) {
                s++;
            }
        }
        m_verticalProfile.push_back(s);
    }

    //applyConvolutions();
}*/

HorizontalRunLenghtProfiler::~HorizontalRunLenghtProfiler()
{
//    if (m_img)
//        delete m_img;
}




void HorizontalRunLenghtProfiler::computeProfile (const QImage &image, bool threshold)
{
    QVector<size_t> h;
    QVector<size_t> v;

    m_img = image.copy().convertToFormat(QImage::Format_ARGB32);
    QImage log = m_img.copy();

    for (int j = 0; j< image.height(); j++) {
        int s = 0;
        for (int i = 0; i< image.width(); i++) {
            /// if == 1 = white = ink

            if (qGray(image.pixel(i,j)) == 255) {
                log.setPixel(i,j, qRgb(0, 255, 0));
                s++;
            }
        }

        h.push_back(s);
    }
    log.save("HorizontalProfilePixels.png");

    for (int i = 300; i< image.width(); i++) {
        int s = 0;
        for (int j = 0; j< image.height(); j++) {
            if (qGray(image.pixel(i,j)) == 255) {
                s++;
            }
        }

        v.push_back(s);
    }

    ProfileThresholder thd;
    if(threshold) {
        m_horizontalProfile = thd.thresholdedHorizontal(h,(int) CollectionUtils::mean(h));
        m_verticalProfile = thd.thresholdedVertical(v,(int) CollectionUtils::mean(v));
    } else {
        //m_horizontalProfile = h;
        m_horizontalProfile  = thd.thresholdedCleanHorizontal(h,(int) CollectionUtils::mean(h));
        m_verticalProfile = thd.thresholdedVertical(v,(int) CollectionUtils::trimedmean(v));
    }
    //m_horizontalProfile = h;
    //m_verticalProfile = v;
}

void HorizontalRunLenghtProfiler::toCSVFile(QString filename)
{
    QFile file(filename);
    file.open(QIODevice::ReadWrite);
    QTextStream stream(&file);
    int i = 0;
    foreach (int sum, m_horizontalProfile) {
        stream << i << ";" << sum << "\n";
        i++;
    }

//    foreach (int sum, m_verticalProfile) {
//        stream << i << ";" << sum << "\n";
//        i++;
//    }
}

QImage HorizontalRunLenghtProfiler::verticalToImage()
{
    int x=0;
    int thd = 0;
    QImage img = m_img.copy();
    foreach (int sum, m_verticalProfile) {
        if (sum > thd) {
            for (int y = 0;
                 y <= sum && x < img.width()
                 && y < img.height(); y++) {
                img.setPixel(x, y, qRgb(255, 0, 0));
            }
        }
        x++;
    }

//    foreach (int sum, m_horizontalProfile) {
//        if (sum > thd) {
//            for (int x = 0;
//                 x <= sum && x < img.width()
//                 && y < img.height(); x++) {
//                img.setPixel(x, y, qRgb(255, 0, 0));
//            }
//        }
//        y++;
//    }

    return img;
}

QImage HorizontalRunLenghtProfiler::horizontalToImage()
{
    int y=0;
    int thd = 0;
    QImage img = m_img.copy();

    foreach (int sum, m_horizontalProfile) {
        if (sum > thd) {
            for (int x = 0;
                 x <= sum && x < img.width()
                 && y < img.height(); x++) {
                img.setPixel(x, y, qRgb(255, 0, 0));
            }
        }
        y++;
    }

    return img;
}

/*class HorizontalRunLenghtProfilerOnRegion : public girl::toger::pointIterator {

public :

    HorizontalRunLenghtProfilerOnRegion(const girl::tools::Image &img,
                                        QVector<size_t> &profile,
                                        int thd0,
                                        int thd1)
        : m_img (img)
        , m_profile (profile)
        , m_thd0 (thd0)
        , m_thd1 (thd1)
    {
        /// Qt's containers automatically initialize the value to 0.
        profile.resize(img.height());
    }

    virtual void processPoint(const girl::point &p)
    {
        if (m_img.getPixel (p.x(), p.y()) [0] < m_thd0
                && m_img.getPixel (p.x(), p.y()) [0] < m_thd1) {
            m_profile[p.y()]++;
        }
    }

private :

    const girl::tools::Image &m_img;
    QVector<size_t> &m_profile;
    int m_thd0;
    int m_thd1;
};*/

/*void HorizontalRunLenghtProfiler::computeProfile(const girl::tools::Image &image,
                                                 const girl::regionDeque &regions,
                                                 const girl::toger &tog)
{
    HorizontalRunLenghtProfilerOnRegion runlen (image, m_horizontalProfile, m_thd0, m_thd1);
    foreach (girl::region r, regions) {
        tog.iterateOnRegionDomain(r, runlen);
    }
}*/

#include "ProfileThresholder.hpp"

/*girl::tools::Image HorizontalRunLenghtProfiler::toImage (int thd)
{
    if (m_img->isNull()) throw "image is null : profile may not be computed";

    girl::tools::Image img;
    m_img->clone(img);

    ProfileThresholder thdMethod;

//    std::cout << "toImage " << std::endl;
//    int y=0;
//    foreach (int sum, thdMethod.thresholded(m_horizontalProfile, thd)) {
//            for (int x = 0; x <= sum && x < img.width() && y < img.height(); x++) {
//                img.setPixel(x, y, *m_pixelForImage);
//        }
//        y++;
//    }
    std::cout << "back from toImage " << std::endl;

    int x=0;
    foreach (int sum, m_verticalProfile) {
        if (sum > thd) {
            for (int y = 0; y <= sum && x < img.width() && y < img.height(); y++) {
                img.setPixel(x, y, *m_pixelForImage);
            }
        }
        x++;
    }
    return img;
}*/

/*void HorizontalRunLenghtProfiler::setColorLogPixel(girl::tools::PixelStandAlone<unsigned short> *pixel)
{
    m_pixelForImage = pixel;
}*/

QVector<size_t> HorizontalRunLenghtProfiler::getHProfile()
{
    return m_horizontalProfile;
}

QVector<size_t> HorizontalRunLenghtProfiler::getVProfile()
{
    return m_verticalProfile;
}


/*girl::tools::Image HorizontalRunLenghtProfiler::toHistogram(QVector<size_t> hProfile1, int thd1, QVector<size_t> hProfile2, int thd2)
{
    if (m_img->isNull()) throw "image is null : profile may not be computed";

    girl::tools::Image image(2*m_img->width(), hProfile1.size(), m_img->channels());

    int y=0;
    foreach (int sum, hProfile1) {
        if (sum > thd1) {
            for (int x = 0; x <= sum; x++) {
                if (x < image.width() && y < image.height())
                    image.setPixel(x, y, *m_pixelForImage);
            }
        }
        y++;
    }
    setColorLogPixel(&DoQuMeasures::Pixels::bleu);
    y=0;
    foreach (int sum, hProfile2) {
        if (sum > thd2) {
            for (int x = 600; x < image.width() &&  x <= 600 + sum; x++) {
                if (y < image.height())
                    image.setPixel(x, y, *m_pixelForImage);
            }
        }
        y++;
    }
    return image;
}*/

void HorizontalRunLenghtProfiler::applyConvolutions()
{
    for (int i=2; i < m_horizontalProfile.size()-2; i++) {
        m_horizontalProfile[i] =
                ( 1*m_horizontalProfile.at(i-2)
                + 2*m_horizontalProfile.at(i-1)
                + 2*m_horizontalProfile.at(i)
                + 2*m_horizontalProfile.at(i+1)
                + 1*m_horizontalProfile.at(i+2)
                 ) / (1+2+2+2+1);
    }

}

