#ifndef HORIZONTALRUNLENGHTPROFILER_HPP
#define HORIZONTALRUNLENGHTPROFILER_HPP


#include <QVector>
#include <QImage>


class HorizontalRunLenghtProfiler
{
public:
    HorizontalRunLenghtProfiler ();
    ~HorizontalRunLenghtProfiler ();

    void computeProfile (const QImage &image, bool threshold);
    /// todo to be tested
    //void computeProfile (const girl::tools::Image &image,const girl::regionDeque &regions, const girl::toger &tog);
    //void computeProfile (girl::tools::Image *img);

    void toCSVFile(QString filename);
    QImage verticalToImage ();
    QImage horizontalToImage ();

    //girl::tools::Image toHistogram ( QVector<size_t> hProfile1, int thd1,
     //                                       QVector<size_t> hProfile2, int thd2);

    ///// Getters && Setters
    //void setColorLogPixel (girl::tools::PixelStandAlone<short unsigned int> *pixel);

    QVector<size_t> getHProfile ();
    QVector<size_t> getVProfile ();
private :
    void applyConvolutions();

private :
    int m_thd0;
    int m_thd1;

    QVector<size_t> m_horizontalProfile;
    QVector<size_t> m_verticalProfile;

    QImage m_img;
    //girl::tools::Image *m_img;
    //girl::tools::PixelStandAlone<short unsigned int> *m_pixelForImage;

};

#endif // HORIZONTALRUNLENGHTPROFILER_HPP
