#include "RegisterWithProfiles.hpp"

#include "HorizontalRunLenghtProfiler.hpp"
#include "CollectionUtils.hpp"

#include <DoQuBook/Dtw.hpp>
#include "VerticalRegistration.hpp"
#include "ProfileThresholder.hpp"
#include <QDebug>

//#include "DoQuMeasures/Registration/RegistrationMetric.hpp>



RegisterWithProfiles::RegisterWithProfiles(QObject *parent)
{
    dx= 0;
    dy=0;
    angle=0;

}

/*girl::tools::Image bleedThroughToBlack(const girl::tools::Image &img, int thdInk, int thdBackground) {

    girl::tools::Image  out (img.width(), img.height(), img.channels());
    for (int i = 0; i < img.width(); i++)
    {
        for (int j = 0; j < img.height(); j++)
        {
            if(img.getPixel(i,j)[0] > thdInk && img.getPixel(i,j)[0] <= thdBackground)
                out.setPixel(i,j, Pixels::noir);
            else
                out.setPixel(i, j, Pixels::blanc);
        }
    }
    return out;
}*/

#include <DoQuBook/PluginLoader.hpp>
#include <DoQuBook/Binarizer.hpp>
using namespace  DoQuBook;

void RegisterWithProfiles::compute(const QImage &recto, const QImage &verso)
{

    otsu2TLevels(recto);

    dyShouldBeCancelled = 0;

    recto.save("recto_tmp.png");
    verso.save("verso_tmp.png");

    // FAIRE OTSU
    //QList<int> otsuLevels = otsu2TLevels(recto);
    //int inkthd  = otsuLevels.at(0);
    //int backThd = otsuLevels.at(1);

    //int inkthd  = 162;
    //int backThd = 182;



    //qDebug() << "InkThd : "<< inkthd ;
    //qDebug() << "BackThd : "<< backThd;

    PluginLoader &loader = PluginLoader::instanceRef();

    QString binarizerName = "BleedThrough";
    BinarizerPtr bleedBinarizer = loader.getPlugin<Binarizer>(binarizerName);
    QImage bleedRecto = bleedBinarizer->binarize(recto);

    BinarizerPtr otsubinarizer = loader.getPlugin<Binarizer>("Binarizers::BinarizationOtsu2T");
    QImage binVerso = otsubinarizer->binarize(verso);

    /// Faire deskew avec plugin
    //OCRUtils::Deskew deskew;
    //angle = deskew.deskewAngle("toto.png");



    HorizontalRunLenghtProfiler profiler_recto;
    profiler_recto.computeProfile (bleedRecto, true);
    profiler_recto.toCSVFile("Horizontal.csv");
    profiler_recto.verticalToImage().save("ProfileRectoVertical.png");
    profiler_recto.horizontalToImage().save("ProfileRectoHoriz.png");


    int vRectoProfileThd = 0;
    //CollectionUtils::trimedmean(profiler_recto.getVProfile());
    int hRectoProfileThd = 0;
    //CollectionUtils::trimedmean(profiler_recto.getHProfile());

    qDebug() << "mean of vprofile recto : " << vRectoProfileThd;
    qDebug() << "mean of hprofile recto : " << hRectoProfileThd;

    //imageProfilesRecto = profiler_recto.toImage (hRectoProfileThd);

    /// TODO versoOtsu
    //int versoOtsuZero = 109;

    HorizontalRunLenghtProfiler profiler_verso;
    profiler_verso.computeProfile (binVerso, false);
    profiler_verso.verticalToImage().save("ProfileVersoVertical.png");
    profiler_verso.horizontalToImage().save("ProfileVersoHoriz.png");
    //exit(0);
    int vVersoProfileThd = 0;
    int hVersoProfileThd = 0;// CollectionUtils::trimedmean(profiler_cerso.getHProfile());;
    qDebug() << "mean of vprofile verso : " << vVersoProfileThd;
    qDebug() << "mean of hprofile verso : " << hVersoProfileThd; //CollectionUtils::trimedmean(profiler_cerso.getHProfile());
    // profiler_cerso.toCSVFile ("profile_verso.csv");

    //imageProfilesVerso = profiler_verso.toImage (hVersoProfileThd);




    Dtw dtw;
    Dtw::DTWResult result;
    result = dtw.classify(CollectionUtils::normed(profiler_verso.getHProfile().toList()),
                          CollectionUtils::normed(profiler_recto.getHProfile().toList())
                          );
    hdtx_distance = result.distance;
    qDebug() << "Distance = " << result.distance;

    VerticalRegistration registration;
    dy = registration.meanDy (dtw.getBestPath(), profiler_recto.getHProfile(), profiler_verso.getHProfile());
    qDebug() << "decallage mean Y = " << dy;

    dyShouldBeCancelled = (dy >= -1 && dy <= 1) ? 1 : 0;

    //RegistrationMetric rm;
    //merrorHProfiles = rm.compute(profiler_recto.getHProfile().toList(), profiler_verso.getHProfile().toList(), dy);
    merrorHProfiles = dtw.m_lastResult.distance / profiler_recto.getHProfile().size();
    qWarning() << merrorHProfiles;
    //errorHProfilesBeforeRegistration = rm.compute(profiler_recto.getHProfile().toList(), profiler_verso.getHProfile().toList(), 0);
    qDebug() << "percentage de diff moyen en Y : " << merrorHProfiles;


    Dtw vDtw;
    Dtw::DTWResult vResult;
    vResult =  vDtw.classify (profiler_verso.getVProfile().toList(),
                              profiler_recto.getVProfile().toList());
    qDebug() << "vdtw distance = " << vResult.distance;
    vdtw_distance = vResult.distance;

    dx = registration.meanDy (vDtw.getBestPath(), profiler_recto.getVProfile(), profiler_verso.getVProfile());
    qDebug() << "decallage mean X = " << dx;
    //merrorVProfiles = rm.compute(profiler_recto.getVProfile().toList(), profiler_verso.getVProfile().toList(), dx);
    //errorVProfilesBeforeRegistration = rm.compute(profiler_recto.getVProfile().toList(), profiler_verso.getVProfile().toList(), 0);

    qDebug() << "percentage de diff moyen en X : " << merrorVProfiles;
}



void RegisterWithProfiles::toStream(QTextStream &out) const
{
    out  << dx << " ; "  << dy << " ; " << angle << " ; "
         << merrorVProfiles << " ; " << vdtw_distance << " ; " << merrorHProfiles << " ; " << hdtx_distance << " ; "
         << errorHProfilesBeforeRegistration << " ; " <<  dyShouldBeCancelled << ";" << errorVProfilesBeforeRegistration << ";"/*<< histoDiff<< " ; "*/;
}

QTextStream & operator <<(QTextStream & out, const RegisterWithProfiles &rm)
{
    rm.toStream(out);
    return out;
}

void RegisterWithProfiles::header(QTextStream &out)
{
    out  << " dx " << " ; " << " dy " << " ; " << " angle " << " ; "
         <<" merrorVProfiles " << " ; "<< " vdtw_distance " << " ; "  << " merrorHProfiles " << " ; " << " hdtx_distance " << ";"
        << " errorHProfilesBeforeRegistration " << " ; " <<" dyShouldBeCancelled" << ";" << " errorVProfilesBeforeRegistration "<< ";"/*<< histoDiff<< " ; "*/;
}

Transform RegisterWithProfiles::registerPages(const QImage &recto, const QImage &verso)
{

    compute(recto, verso);
    return Transform(merrorHProfiles, dx, dy);
}

void RegisterWithProfiles::log(QDir &outDir, QFileInfo &fileInfoRecto)
{

    QString logFilePath = outDir.absolutePath()+"/"+fileInfoRecto.fileName();
    QString profileRecto_path = logFilePath+"_profile_recto.png";
    QString profileVerso_path = logFilePath+"_profile_verso.png";
    QString bleedTrinRecto_path = logFilePath+"_trin_recto.png";
    //getImageProfilesRecto().save(profileRecto_path.toStdString());
    //getImageProfilesVerso().save(profileVerso_path.toStdString());
    //getBleedTrinarized().save(bleedTrinRecto_path.toStdString());

}

#include <cv.h>
#include <highgui.h>
#include <iostream>
#include <DoQuBook/DoQuBookOpenCVConverter.hpp>

#include <ise/iseSegmentationContext.hpp>
#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseSplitAlgorithm.hpp>
#include <ise/iseSplitDriverDefault.hpp>
#include <ise/iseSplitAlgorithmDefault.hpp>
#include <ise/iseQuantificationThresholderOtsu2T.hpp>
#include <ise/iseHistogram1D.hpp>
#include <ise/iseSegmentationClusteringLocalThresholds.hpp>
#include <ise/iseSegmentationClusteringLocalThresholderSauvola.hpp>

#include <girl/girlCommon.hpp>
#include <girlTools/girlToolsRegionInfos.hpp>

using namespace DoQuBook;

QList<int> RegisterWithProfiles::otsu2TLevels(const QImage &qimage)
{
    DoQuBookOpenCVConverter converteur;
    cv::Mat src = converteur.getCvMat(qimage);

    girl::tools::Image image (src);

    ise::QuantificationThresholderOtsu2T quantif;
    ise::Histogram1D h(image, 0, 0, 255);
    std::vector<double> levels;
    quantif.getThresholds(h, levels);
    QList<int> qtLevels;
    qtLevels << levels[0] << levels[1];
    qDebug() << levels[0] << " " << levels[1];


    cv::Mat g_gray = cv::Mat::zeros(src.rows, src.cols, CV_8UC1);;
    cv::cvtColor( src, g_gray, CV_RGB2GRAY );


    QImage img (image.width(), image.height(), QImage::Format_ARGB32);

    for(int i = 0; i < image.width(); i++) {
        for(int j = 0; j < image.height(); j++) {
            girl::tools::PixelFromImage<girl::tools::Image::type> pixel = image.getPixel(i,j);
            if(pixel[0] <= levels[0] )
                img.setPixel(i,j, qRgb(0,0,0));
            else if(pixel[0] > levels[0]
                    && pixel[0] <= levels[1])
                img.setPixel(i,j, qRgb(255,0,0));
            else if(pixel[0] > levels[1])
                img.setPixel(i,j, qRgb(255,255,255));

        }
    }

    img.save("Trinarization.png");

    return qtLevels;
}
