#ifndef REGISTERWITHPROFILES_HPP
#define REGISTERWITHPROFILES_HPP


#include <QTextStream>
#include <QDir>
#include <QImage>

class Transform {
public :
    Transform (double angle, int dx, int dy)
        : m_angle(angle)
        , m_dx(dx)
        , m_dy(dy)
    {}
public :
    double m_angle;
    int m_dx;
    int m_dy;
};


class RegisterWithProfiles
{
public:
    virtual ~RegisterWithProfiles() {}
    virtual  Transform registerPages(const QImage &recto, const QImage &verso);
    virtual void log(QDir &out, QFileInfo &fileInfoRecto);

    QList<int> otsu2TLevels(const QImage &image);


    void toStream(QTextStream & out) const;
    static void header(QTextStream & out);
    friend QTextStream & operator <<(QTextStream & out, const RegisterWithProfiles &rm);

    /*girl::tools::Image getImageProfilesRecto()
    {return imageProfilesRecto;}
    girl::tools::Image getImageProfilesVerso()
    {return imageProfilesVerso;}
    girl::tools::Image getBleedTrinarized()
    {return bleedTrin;}*/

protected :
    void compute(const QImage &recto, const QImage &verso);

public :
    explicit RegisterWithProfiles(QObject *parent = 0);

private :
    double angle;
    int dx;
    int dy;
    double merrorHProfiles;
    double merrorVProfiles;

    double errorHProfilesBeforeRegistration;
    double errorVProfilesBeforeRegistration;

    int dyShouldBeCancelled;

    int vdtw_distance;
    int hdtx_distance;

    double histoDiff;

    /*girl::tools::Image imageProfilesRecto;
    girl::tools::Image imageProfilesVerso;
    girl::tools::Image bleedTrin;*/
};

QTextStream & operator <<(QTextStream & out, const RegisterWithProfiles &rm);


#endif // REGISTERWITHPROFILES_HPP
