#include "RegistrationDTW.hpp"
#include <QDebug>
#include <QtPlugin>

#include "RegisterWithProfiles.hpp"
using namespace DoQuBook;

RegistrationDTW::RegistrationDTW()
{
}

RegistrationDTW::~RegistrationDTW()
{}

QTransform RegistrationDTW::compute(const QList<QImage> &images)
{
    QImage recto = images.at(0);
    QImage verso = images.at(1);

    RegisterWithProfiles registration;
    Transform t = registration.registerPages(recto, verso);
    qDebug() << t.m_dx;
    qDebug() << t.m_dy;
    qDebug() << t.m_angle;

    QTransform transform;
    transform.translate(t.m_dx, t.m_dy);
    transform.rotate(t.m_angle);

    return transform;
}

Q_EXPORT_PLUGIN2(registrationDTWPlugin, RegistrationDTW)



