#include "VerticalRegistration.hpp"

VerticalRegistration::VerticalRegistration()
{
}

QImage VerticalRegistration::registerImage(const QImage &recto,
                                                       const QImage &verso,
                                                       const QHash<int, int> &assocs)
{
    QImage image = recto.copy();


    QHashIterator<int, int> i(assocs);
    while (i.hasNext()) {
        i.next();
        int y = i.key();
        int y_decallage = i.value();
        //std::cout << y << "  " << y_decallage << std::endl;
        if(y < recto.height()) {
            //  std::cout << " recallage de "<< y << std::endl;
            for (int x = 0; x < recto.width(); x++) {
                image.setPixel(x, y, recto.pixel(x, y_decallage));
            }
        }
    }

    return image;
}

int positionOfMax(QVector<size_t> hProfile) {
    int i = 0;
    int max_position = i;
    size_t max = hProfile.at(i);

    while (i < 400) {
        i++;
        if (hProfile.at(i) > max) {
            max = hProfile.at(i);
            max_position = i;
        }
    }
    return max_position;
}

int VerticalRegistration::meanDy(Dtw::BinMatchList assocs, QVector<size_t> hProfile1, QVector<size_t> hProfile2 )
{
    // On trouve les max dans les profiles.
    //int maxIndexProfile1 = positionOfMax(hProfile1);
    //int maxIndexProfile2 = positionOfMax(hProfile2);

    //   Dtw::BinMatch match = assocs.getAll (maxIndexProfile1).at(0);
    //   int dy = match.templ_x-match.obs_x;
    //   return dy;


    //Methodes des max
    //    int dy = maxIndexProfile2 - maxIndexProfile1;
    //    return dy;

    int lastTemplx = -1;
    int lastObsx = -1;
    int decalageGauche = 0;
    int decalageDroite = 0;

    int sum = 0;
    int nb = 0;
    foreach (Dtw::BinMatch match, assocs.getBestPath()) {
        //std::cout << "X : " << match.templ_x << "  Y : "<< match.obs_x << std::endl;
        //         std::cout << "lX : " << lastTemplx << "  lY : "<< lastObsx << std::endl;


        //        if (match.templ_x != lastTemplx &&  match.obs_x != lastObsx ) {
        //            std::cout <<  "Gauche " << decalageGauche << " Droite " << decalageDroite << " = " << (decalageDroite) << std::endl;

        //            sum += /* hProfile2.at(match.templ_x) *  */ (decalageDroite);
        //            nb += 1; //hProfile2.at(match.templ_x);
        ////            if(decalageDroite > 100 || decalageGauche > 100) {

        ////                std::cout <<  "Gauche " << decalageGauche << " Droite " << decalageDroite << " = " << (decalageDroite-decalageGauche) << std::endl;
        ////            }
        //            decalageGauche = 0;
        //            decalageDroite = 0;

        //        }
        //        if (match.templ_x == lastTemplx) {
        //             sum+= decalageGauche;
        //             nb++;
        //         }
        //std::cout << match.templ_x << "     " << match.obs_x << std::endl;
        if(match.templ_x != match.obs_x) {
            if( match.templ_x != lastTemplx && match.obs_x != lastObsx) {
                decalageGauche = (match.templ_x - match.obs_x);
                // std::cout << "decallage = "<<  decalageGauche << std::endl;
                lastObsx = match.obs_x;
                lastTemplx = match.templ_x;
                sum+=decalageGauche;
                //std::cout << decalageGauche << std::endl;
                nb++;//hProfile1.at(match.templ_x);

            }
        }

    }
    if(nb == 0) return 0;

    int dy = sum/nb;
    return dy;
}
