#include "TestRegistrationDTW.hpp"

#include "RegistrationDTW.hpp"
#include <DoQuBook/PluginLoader.hpp>
#include <QApplication>
#include <math.h>
#include <QPainter>

#ifndef M_PI
   #define M_PI 3.14159265358979323846
#endif

QImage transformed(const QImage &image, QTransform t)
{
    QPainter cpaint;
    QImage out(image.size(),image.format());
    for (int n = 0; n < out.width(); n++) {
        for (int m = 0; m < out.height(); m++) {
            QRgb p;
            if(n+t.dx() < image.width()
                    && m+t.dy() < image.height())
                p = image.pixel(n+t.dx(),m+t.dy());
            else
                p = qRgb(255,255,255);
            out.setPixel(n,m, p);
        }
    }

    return out;
}


void TestDeskewOCROpus::testPlugin()
{
    QString plugins_dir_path = qApp->applicationDirPath()+"/../plugins";
    DoQuBook::PluginLoader::instance()->setPluginDirPath(plugins_dir_path);
    
    RegistrationDTW plugin;

    QImage testImage (":/images/doc");
   /* QList<QImage> images;
    images << testImage;
    images << testImage;

    QTransform t = plugin.compute(images);
    */


    QTransform trans;
    trans.translate(150, 150);

    QList<QImage> imagesTranslated;
    imagesTranslated << testImage;
    testImage.save("TestImage.png");
    QImage testTranslateImage = transformed(testImage,trans);
    testTranslateImage.save("TranslatedImage.png");
    imagesTranslated << testTranslateImage;


    plugin.compute(imagesTranslated);


/*    qDebug() << t.dx();
    qDebug() << t.dy();
    qDebug() << acos(t.m11()) * 180.0 / M_PI;

    QTransform theTransform;
    theTransform.rotate(10);
    */
}

void TestDeskewOCROpus::init()
{
}

void TestDeskewOCROpus::cleanup()
{
}

QTEST_MAIN(TestDeskewOCROpus)
