#include "TestIseCooccurrencePixelFeaturesComputer.hpp"

#include <IseCooccurrencePixelFeaturesComputer.hpp>
#include <DoQuBook/PluginLoader.hpp>
#include <QApplication>
#include "Config.hpp"

#include <DoQuBook/RegionExtractor.hpp>

using namespace DoQuBook;



void TestIseCooccurrencePixelFeaturesComputer::testPlugin()
{
  QImage testImage (DATA_DIR+"img2.png");
  QVERIFY(!testImage.isNull());

  // Extract regions
  DoQuBook::RegionFeaturesListPtr regionsWithfeats;

  { // auto delete un needed stuffs
    PluginLoader *loader = PluginLoader::instance();
    BinarizerPtr binarizer = loader->getPlugin<Binarizer>("labri.OtsuBinarization.0.1.1");
    QImage binarized = binarizer->binarize(testImage);

    RegionExtractorPtr regionExtractor = loader->getPlugin<RegionExtractor>("labri.RegionExtractorISEWhiteCCPlugin.0.1.1");
    RegionListPtr regions = regionExtractor->extractRegions(binarized);

    IseCooccurrencePixelFeaturesComputer plugin;
    regionsWithfeats = plugin.extract(testImage, regions);
  }

  QFile file("./feats.txt");
  file.open(QIODevice::WriteOnly | QIODevice::Text);
  QTextStream out(&file);

  foreach (const DoQuBook::RegionFeaturesPtr & f, regionsWithfeats->features()) {
    out << "r" << "\t" ;
    foreach (const double &d, f->features()) {
      out << "\t" << d;
    }
    out << "\n";
  }
  file.close();
}

void TestIseCooccurrencePixelFeaturesComputer::init()
{
}

void TestIseCooccurrencePixelFeaturesComputer::cleanup()
{
}

QTEST_MAIN(TestIseCooccurrencePixelFeaturesComputer)
