#include "TestLevenshteinDistance.hpp"

#include <LevenshteinDistance.hpp>
#include <DoQuBook/PluginLoader.hpp>
#include <QApplication>

void TestLevenshteinDistance::testPlugin()
{
    QString plugins_dir_path = qApp->applicationDirPath()+"/../plugins";
    DoQuBook::PluginLoader::instance()->setPluginDirPath(plugins_dir_path);
    
     LevenshteinDistance plugin;
     int nbLettersMax = QString("examen").length();
     QVERIFY (plugin.compare("examen", "examen") == 100*0 / nbLettersMax);
     QVERIFY (plugin.compare("examen", "examan") == 100*1 / nbLettersMax);
     QVERIFY (plugin.compare("examen", "exeman") == 100*2 / nbLettersMax);
     nbLettersMax = std::max(QString("examen").length(), QString("exemane").length());
     QVERIFY (plugin.compare("examen", "exemane") == 100*3 / nbLettersMax);
     nbLettersMax = std::max(QString("examen").length(), QString("exament").length());
     QVERIFY (plugin.compare("examen", "exament") == 100*1 / nbLettersMax);
}

void TestLevenshteinDistance::init()
{
}

void TestLevenshteinDistance::cleanup()
{
}

QTEST_MAIN(TestLevenshteinDistance)
