# - Try to find ISE 
# Once done, it will define
#
# ISE_FOUND - system has ISE
# ISE_INCLUDE_DIRS - ISE include directories
# ISE_DEFINITIONS - Compiler switches required for using ISE
# ISE_LIBRARIES - link these to use ISE

#include(LibFindMacros)


IF (OCRopus_INCLUDE_DIRS AND OCRopus_LIBRARIES)
   # in cache already
   SET(OCRopus_FIND_QUIETLY TRUE)
ENDIF (OCRopus_INCLUDE_DIRS AND OCRopus_LIBRARIES)


# Include dir
find_path(iulib_INCLUDE_DIR
  NAMES iulib/iulib.h
  PATHS /usr/include
	/usr/local/include )

# Library
find_library(iulib_LIBRARY
  NAMES iulib
  PATHS /usr/lib
	/usr/local/lib )




INCLUDE(FindPackageHandleStandardArgs)

# handle the QUIETLY and REQUIRED arguments and set ISE_FOUND to TRUE if 
# all listed variables are TRUE
FIND_PACKAGE_HANDLE_STANDARD_ARGS(iulib DEFAULT_MSG iulib_LIBRARY iulib_INCLUDE_DIR)

IF (IULIB_FOUND)
  set(iulib_INCLUDE_DIRS ${iulib_INCLUDE_DIR})
  set(iulib_LIBRARIES ${iulib_LIBRARY})
ENDIF (IULIB_FOUND)


MARK_AS_ADVANCED(iulib_INCLUDE_DIRS iulib_LIBRARIES)

