#include <DoQuBook/PluginLoader.hpp>
#include <DoQuBook/DoQuBookApp.hpp>
#include <DoQuBook/ApplicationContext.hpp>

using namespace DoQuBook;

QString orgName ("your_organization");
/// Must be the name of the target in CMake
QString appName ("DownloadImages");

typedef meta_iterator<PagePtr>::IteratorPtr  PageIteratorPtr;

class DownloadImages : public DoQuBook::DoQuBookApp
{
	public :
	DownloadImages(QCoreApplication &app)
		: DoQuBook::DoQuBookApp(app, orgName, appName)

		{}

	QList<ProgramParameter> paramsAndDescriptions()
	{
		QList<ProgramParameter> params;
				//ProgramParameter param1 ("param1Name", false, "Param1 Description");
				//params.append(param1);
		params << DoQuBook::DoQuBookApp::paramsAndDescriptions();
		return params;
	}

	protected :
	virtual void runApp (QMap<QString, QString> /*args*/)
	{
				// Get the needed services
		DoQuBook::RepositoryPtr repo = DoQuBook::ApplicationContext::instance()->getDefaultRepository();
		PageCollectionServicePtr pageCollectionSrv = repo->getPageCollectionService();

		PageIteratorPtr it = pageCollectionSrv->getPages("(H)DIBCO");
		while(it->hasNext()) {
			try{
				PagePtr page = it->next();
				QImage pageImage = page->getImage();
				pageImage.save(page->getName()+".png");
			}catch (MessageException e) {
				qCritical() << tr("Error occured") << e.message();
			}
		}
	}
};


int main(int argc, char *argv[])
{
	QCoreApplication app(argc, argv);
	DownloadImages myApp (app);
	return myApp.exec();
}
