#include "NewBookListener.hpp"
#include <GrowlCpp/growlnotifier.hpp>
#include <QSettings>
#include <QDir>
#include <QDebug>

using namespace DoQuBook;


NewBookListener::NewBookListener(QApplication &app)
  : DoQuBookApp(app)
  {}


void NewBookListener::install() 
{
  QSettings settings("~/Library/LaunchAgents/com.labri.DoQuBookNotifier.plist",
                     QSettings::NativeFormat);
  settings.setValue("Disabled", false);
  settings.setValue("Label", "com.labri.DoQuBookNotifier");
  settings.setValue("WorkingDirectory", "/Users");
  settings.setValue("RunAtLoad", true);
  settings.setValue("StartInterval", 360);

  settings.setValue("Program", _app.applicationDirPath()+"/DoQuBookNotifier");
  
  settings.sync();                   
}

void NewBookListener::run()
{
  QSettings settings("labri", "DoQuBookNotifier");

  int size =  settings.beginReadArray("knownBooks");
  QList<int> allreadyNotifiedIds;
  for(int i = 0; i < size; i++) {
    settings.setArrayIndex(i);
    int id = settings.value("id").toInt();
    allreadyNotifiedIds.append(id);
  }
  settings.endArray();

    /// The name of the repo provided in DoQuAnnotator
  QString repoName = "Gallifrey";
    /// Get the repository
  DoQuBook::RepositoryPtr repo = DoQuBook::ApplicationContext::instance()->getRepository(repoName);
    /// And the associated book provider.
  DoQuBook::BookProviderPtr provider = repo->getProvider();
     /// Using the provider we retreive the books ids :
  QList<int> bookIds = provider->getAllBooks ();
  settings.beginWriteArray("knownBooks");
  int i = 0;
  foreach(int id, bookIds)
  {
    settings.setArrayIndex(i);
    if(! allreadyNotifiedIds.contains(id)) {
      BookPtr b = provider->get(id);
      qDebug() << b->getName();
      GrowlNotifier notifier;
      notifier.notify("New Book !", b->getName().toStdString()+" was added on Gallifrey");
      settings.setValue("id", id);
    }
  }
  settings.endArray();
  settings.sync();
}
