#include "CSharpClassBuilder.hpp"
#include <QDebug>

CSharpClassBuilder::CSharpClassBuilder(Entity &e)
: ClassBuilder(e, "csharp", ".cs")
{
}

void CSharpClassBuilder::moreTemplatesOnDeclarationFile(QString &templ)
{
    // set up the namespace
    templ.replace("${NAMESPACE}", getNamespace() + lang() .toUpper() );
}

QString CSharpClassBuilder::getFieldType(const Field &f)
{
    if(f.isList() && f.isMarshallable())
        return "List<"+f.type()+"Ptr>";
    else if (f.isMap())
        return "Dictionary<"+f.key()+","+f.type()+">";
    else
        return f.type();
}


void CSharpClassBuilder::moreTemplatesOnImplementationFile(QString &templ)
{
}

QString CSharpClassBuilder::getInheritKeyword()
{
    return ":";
}

QString CSharpClassBuilder::getInheritDefaultKeyword()
{
    return "";
}

QString CSharpClassBuilder::getInheritDefaultParent()
{
    return "";
}

