#ifndef CPPCLASSBUILDER_HPP
#define CPPCLASSBUILDER_HPP

#include <QString>
#include "ClassBuilder.hpp"

class CppClassBuilder : public ClassBuilder
{
public:
    CppClassBuilder(Entity &e);

    virtual QString getFieldType(const Field &f);
    virtual QString getFieldAnnotations(const Field&f);

protected:

    virtual void moreTemplatesOnDeclarationFile(QString & templ);
    virtual void moreTemplatesOnImplementationFile(QString & templ);

    /// permit to setup inheritence schemes
    virtual QString getInheritKeyword();
    virtual QString getInheritDefaultKeyword();
    virtual QString getInheritDefaultParent();

    virtual QString imports();


};

#endif // CPPCLASSBUILDER_HPP
