#include "Entity.hpp"


Field::Field(const QString &type, QString &name)
    : _type (type)
    , _name (name)
    , _id(false)
    , _isList(false)
    , _isMap(false)
    , _isMarshallable (false)
{
}

Field::Field(const QString &key, const QString &type, QString &name)
{
    (*this) = Field(type, name);
    _key = key;
    setIsMap(true);
}

QString Field::type() const
{
    return _type;
}

QString Field::name() const
{
    return _name;
}

QString Field::key() const
{
    return _key;
}


bool Field::isId() const
{
    return _id;
}

void Field::setId(bool id)
{
    _id = id;
}


void Field::setIsList(bool isList)
{
    _isList = isList;
}

bool Field::isList() const
{
    return _isList;
}

void Field::setIsMap(bool isMap)
{
    _isMap = isMap;
}

bool Field::isMap() const
{
    return _isMap;
}

CRUDMethods::CRUDMethods(bool create, bool read, bool update, bool del)
    : _create (create)
    , _read (read)
    , _update (update)
    , _del (del)
{
}

bool CRUDMethods::create()
{
    return _create;
}

bool CRUDMethods::read()
{
    return _read;
}

bool CRUDMethods::update()
{
    return _update;
}

bool CRUDMethods::del()
{
    return _del;
}

Method::Method(const QString &name)
    : _name (name)
{
}

void Method::addParam(const Field &f)
{
    _params.append(f);
}

QList<Field> Method::getParams()
{
    return _params;
}

Entity::Entity()
{
}

void Field::setIsMarshallable(bool isMarshallable)
{
    _isMarshallable = isMarshallable;
}

bool Field::isMarshallable() const
{
    return _isMarshallable;
}

void Entity::setName(const QString &name)
{
    _name = name;
}

QString Entity::name()
{
    return _name;
}

void Entity::setFields(const QList<Field> &fields)
{
    _fields = fields;
}

QList<Field> Entity::fields()
{
    return _fields;
}

void Entity::addField(const Field &f)
{
    _fields.append(f);
}

void Entity::extends(const QString &parentName)
{
    _parent = parentName;
}

QString Entity::parent()
{
    return _parent;
}
